Attribute VB_Name = "Global"
Option Explicit

'dieser Source kann frei verwendet und weiterentwickelt werden _
fr evtl. auftretende Schden wird nicht gehaftet.


'Konstante          Bedeutung                                       Wert
'SND_ASYNC          Das Programm wartet nicht bis der Sound         1
'                   abgespielt wurde.

'SND_NODEFAULT      Wenn die angegebene Datei nicht gefunden        2
'                   werden konnte, wird nicht der Standartklang
'                   abgespiel.

'SND_SYNC           Der Programm fhrt erst fort, wenn der Sound    0
'                   abgespielt wurde

'SND_LOOP           Der Sound wird solange wiederholt abgespielt    8
'                   bis die sndPlaySound-Funktion erneut, diesmal
'                   aber mit vbNullString anstelle eines Datei-
'                   namens, aufgerufen wird,

'SND_NOSTOP         Der angegebene Sound wird nicht gespielt,       16
'                   wenn gerade ein anderer Sound gespielt wird.

'*** Sound-Funktionen ***
'----------------------------------------------------------------------------------------
'fr das Abspielen der Datei
Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_MEMORY = &H4
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10
Public Const SND_PURGE = &H40
Public Const SND_NOWAIT = &H2000

'Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
(ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Declare Function sndPlaySoundA Lib "Winmm" _
(ByVal IpszSoundName As String, _
ByVal fuOptions As Integer) As Integer

'Public Sound$
Public PfadSound As String
'----------------------------------------------------------------------------------------

Public Declare Function CreatePen Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Public Declare Function Rectangle Lib "gdi32.dll" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Public Declare Function GetSysColor Lib "USER32.DLL" (ByVal nIndex As Long) As Long

Public Const BUTTON_NONE = 0
Public Const BUTTON_UP = 1
Public Const BUTTON_DOWN = 2

'Public Type POINTAPI
'    X   As Long
'    Y   As Long
'End Type

'Public Type RECT
'   Left     As Long
'   Top      As Long
'   Right    As Long
'   Bottom   As Long
'End Type

Public m_oleItemForeColor As OLE_COLOR
Public m_oleBandForeColor As OLE_COLOR
Public BACKGROUND_COLOR As OLE_COLOR ' = &H80000010
Public m_bEnabled As Boolean
Public m_oleDisabledForeColor As OLE_COLOR
Public Const BDR_RAISEDOUTER = &H1
Public Const BDR_SUNKENOUTER = &H2
Public Const BDR_RAISEDINNER = &H4
Public Const BDR_SUNKENINNER = &H8

Public Const BDR_OUTER = &H3
Public Const BDR_INNER = &HC
Public Const BDR_RAISED = &H5
Public Const BDR_SUNKEN = &HA

Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)

Public Const BF_LEFT = &H1
Public Const BF_TOP = &H2
Public Const BF_RIGHT = &H4
Public Const BF_BOTTOM = &H8

Public Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Public Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Public Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Public Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

Public Const BF_DIAGONAL = &H10

' For diagonal lines, the BF_RECT flags specify the end point of
' the vector bounded by the rectangle parameter.
Public Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP _
             Or BF_RIGHT)
Public Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP _
             Or BF_LEFT)
Public Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM _
             Or BF_LEFT)
Public Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM _
             Or BF_RIGHT)

Public Const BF_MIDDLE = &H800    ' Fill in the middle.
Public Const BF_SOFT = &H1000     ' Use for softer buttons.
Public Const BF_ADJUST = &H2000   ' Calculate the space left over.
Public Const BF_FLAT = &H4000     ' For flat rather than 3-D borders.
Public Const BF_MONO = &H8000     ' For monochrome borders.

Public Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Boolean
Public Declare Function PtInRect Lib "user32" (RECT As RECT, ByVal lPtX As Long, ByVal lPtY As Long) As Integer
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
'fr fortlaufenden ToolTipText
Public Const LB_ITEMFROMPOINT = &H1A9
Public Const LB_SETHORIZONTALEXTENT = &H194

Public Sub DreiD_Menue(TempForm As Object)
'Beschreibung:
'Macht aus einem Men ein 3D Men ...

'Code:
With TempForm
    .AutoRedraw = True
    .DrawWidth = 1
    .ScaleMode = 3
    .Cls
    TempForm.Line (0, 0)-Step(.ScaleWidth, 0), vbWhite
    TempForm.Line (0, 1)-Step(.ScaleWidth, 0), vbBlack
    .ScaleMode = 1
    .AutoRedraw = False
End With

'Syntax:
'DreiD_Menue [Formular]
'
'Beispiel:
'DreiD_Menue Me
End Sub

Public Sub playVertikalMenClickSound()

    If PfadSound <> "" Then
        Sound$ = sndPlaySoundA(PfadSound, 2 Or 1)
    End If

End Sub
