Attribute VB_Name = "mdlAdressen"
Option Explicit

Public bAdressdatenndern As Boolean    'fr Daten hinzufgen oder ndern
Public bolDatengendert As Boolean      'wurden Daten gendert ???
Public Const m_strSep As String = "|"
Public Const AdressenDatei As String = "Adressen.db"

Public Const VP_FORMATRANGE = WM_USER + 125
Public Const VP_YESIDO = 456654

Private Type RECT
  Left    As Long
  Top     As Long
  Right   As Long
  Bottom  As Long
End Type

Private Type TFormatRange
  hDC         As Long
  hdcTarget   As Long
  rc          As RECT
  rcPage      As RECT
End Type


'frs leichtere ansprechen der gewnschten Daten
Public Type mAdresse
    mAdrID As Long
    mVorname As String
    mNachname As String
    mGeburtstag As Date
    mStrasse As String
    mHausnummer As String
    mPostleitzahl As String
    mWohnort As String
    mprivFestnetznummer As String
    mprivMobilfunknummer As String
    mgeschFestnetznummer As String
    mgeschMobilfunknummer As String
    mEmailadresse As String
    mBemerkung As String
End Type

'dient fr eine sichere Eingabe der Daten im FlexGrid und _
Index der Textfelder im Eingabeformular fr die Adressen
Public Enum eAdresse
    colID = 0
    colVorname = 1
    colNachname = 2
    colGeburtstag = 3
    colStrasse = 4
    colHausnummer = 5
    colPostleitzahl = 6
    colWohnort = 7
    colprivFestnetznummer = 8
    colprivMobilfunknummer = 9
    colgeschFestnetznummer = 10
    colgeschMobilfunknummer = 11
    colEmailadresse = 12
    colBemerkung = 13
End Enum

Private Const SC_CLOSE = &HF060
Private Const MF_BYCOMMAND = &H0

Public PLZSuchen As Boolean

'Speicher-Variablen zum Erstellen der notwendigen Dateien
Public Anredeliste As String
'die Anrede werden in Anredeliste.db gespeichert
Dim stAnredelisteTemp As String
Dim iKanalNrAnrede As Integer
Dim AnredeNr As Integer

' ----------------------------------------------------------
' Jens Brunsen Software bernimmt keinerlei Haftung fr
' Schden an Hard- oder Software, die durch dieses Beispiel-
' Programm verursacht werden.
' Die Verwendung ist also auf EIGENE GEFAHR !!!!!!
' Der in diesem Beispiel verwendete Source-Code darf frei
' in Ihre eigenen Projekte eingebunden und verwendet werden.
' ----------------------------------------------------------
' (c) 2000 by Jens Brunsen Software
'     http://www.jensbrunsen.de
'     http://www.vb-power.de
'     http://www.freeware-links.de
' ----------------------------------------------------------
'der Verweis auf Microsoft DAO 3.51 Objekt Library (DAO)
'den CompactDatabase wird nicht mehr untersttzt
'NEU: DBEngine mit einem Punkt (.) mu vorangestellt werden

Dim Db As Database
Dim rs As Recordset
Dim dbopen As Boolean

' Entfernen / Anzeigen des Schlieen-Symbols
Public Sub ShowCloseButton(ByVal hwnd As Long, _
  ByVal bShowButton As Boolean)

  Dim hMenu As Long

  If Not bShowButton Then
    ' Schlieen-Symbol deaktivieren
    hMenu = GetSystemMenu(hwnd, 0&)
    If hMenu Then
      Call DeleteMenu(hMenu, SC_CLOSE, MF_BYCOMMAND)
    End If
  Else
    ' Schlieen-Symbol wieder aktivieren
    GetSystemMenu hwnd, True
  End If

  DrawMenuBar hwnd
End Sub

'********************************************************************
'Adressen
'********************************************************************
Public Sub Adressberschriftensetzen()
On Error GoTo Fehlerbehandlung

    With FrmAdressen.grdAdressen
        'Grid leeren
        .Clear
        '1. Reihe mit Spalten anlegen
        .Rows = eAdresse.colID + 1
        .Cols = eAdresse.colBemerkung + 1
        
        'Breiten festlegen
        .ColWidth(eAdresse.colID) = 500
        .ColWidth(eAdresse.colVorname) = 1500
        .ColWidth(eAdresse.colNachname) = 1500
        .ColWidth(eAdresse.colGeburtstag) = 1000
        .ColWidth(eAdresse.colStrasse) = 2000
        .ColWidth(eAdresse.colHausnummer) = 1000
        .ColWidth(eAdresse.colPostleitzahl) = 1000
        .ColWidth(eAdresse.colWohnort) = 1500
        .ColWidth(eAdresse.colprivFestnetznummer) = 2000
        .ColWidth(eAdresse.colprivMobilfunknummer) = 2000
        .ColWidth(eAdresse.colgeschFestnetznummer) = 2000
        .ColWidth(eAdresse.colgeschMobilfunknummer) = 2000
        .ColWidth(eAdresse.colEmailadresse) = 2500
        .ColWidth(eAdresse.colBemerkung) = 2500

        'Beschriften
        .TextMatrix(0, eAdresse.colID) = "ID"
        .TextMatrix(0, eAdresse.colVorname) = "Vorname"
        .TextMatrix(0, eAdresse.colNachname) = "Nachname"
        .TextMatrix(0, eAdresse.colGeburtstag) = "Geburtstag"
        .TextMatrix(0, eAdresse.colStrasse) = "Strae"
        .TextMatrix(0, eAdresse.colHausnummer) = "Haus-Nr"
        .TextMatrix(0, eAdresse.colPostleitzahl) = "PLZ"
        .TextMatrix(0, eAdresse.colWohnort) = "Wohnort"
        .TextMatrix(0, eAdresse.colprivFestnetznummer) = "priv. Festnetz-Nr"
        .TextMatrix(0, eAdresse.colprivMobilfunknummer) = "priv. Mobilfunk-Nr"
        .TextMatrix(0, eAdresse.colgeschFestnetznummer) = "gesch. Festnetz-Nr"
        .TextMatrix(0, eAdresse.colgeschMobilfunknummer) = "gesch. Mobilfunk-Nr"
        .TextMatrix(0, eAdresse.colEmailadresse) = "Emailadresse"
        .TextMatrix(0, eAdresse.colBemerkung) = "Bemerkung"
    End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub ErsterAdressDatensatz()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmAdressen.grdAdressen
    .Row = 1
    datenAdresse.mAdrID = .TextMatrix(1, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(1, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(1, eAdresse.colNachname)
    If IsDate(.TextMatrix(1, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(1, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(1, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(1, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(1, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(1, eAdresse.colWohnort)
    datenAdresse.mprivFestnetznummer = .TextMatrix(1, eAdresse.colprivFestnetznummer)
    datenAdresse.mprivMobilfunknummer = .TextMatrix(1, eAdresse.colprivMobilfunknummer)
    datenAdresse.mgeschFestnetznummer = .TextMatrix(1, eAdresse.colgeschFestnetznummer)
    datenAdresse.mgeschMobilfunknummer = .TextMatrix(1, eAdresse.colgeschMobilfunknummer)
    datenAdresse.mEmailadresse = .TextMatrix(1, eAdresse.colEmailadresse)
    datenAdresse.mBemerkung = .TextMatrix(1, eAdresse.colBemerkung)
End With

With FrmEingabeAdressen
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
    .txtFields(eAdresse.colprivFestnetznummer) = datenAdresse.mprivFestnetznummer
    .txtFields(eAdresse.colprivMobilfunknummer) = datenAdresse.mprivMobilfunknummer
    .txtFields(eAdresse.colgeschFestnetznummer) = datenAdresse.mgeschFestnetznummer
    .txtFields(eAdresse.colgeschMobilfunknummer) = datenAdresse.mgeschMobilfunknummer
    .txtFields(eAdresse.colEmailadresse) = datenAdresse.mEmailadresse
    .txtFields(eAdresse.colBemerkung) = datenAdresse.mBemerkung
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub AdressDatensatzzurck()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmAdressen.grdAdressen
    .Row = .Row - 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
    datenAdresse.mprivFestnetznummer = .TextMatrix(.Row, eAdresse.colprivFestnetznummer)
    datenAdresse.mprivMobilfunknummer = .TextMatrix(.Row, eAdresse.colprivMobilfunknummer)
    datenAdresse.mgeschFestnetznummer = .TextMatrix(.Row, eAdresse.colgeschFestnetznummer)
    datenAdresse.mgeschMobilfunknummer = .TextMatrix(.Row, eAdresse.colgeschMobilfunknummer)
    datenAdresse.mEmailadresse = .TextMatrix(.Row, eAdresse.colEmailadresse)
    datenAdresse.mBemerkung = .TextMatrix(.Row, eAdresse.colBemerkung)
End With

With FrmEingabeAdressen
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
    .txtFields(eAdresse.colprivFestnetznummer) = datenAdresse.mprivFestnetznummer
    .txtFields(eAdresse.colprivMobilfunknummer) = datenAdresse.mprivMobilfunknummer
    .txtFields(eAdresse.colgeschFestnetznummer) = datenAdresse.mgeschFestnetznummer
    .txtFields(eAdresse.colgeschMobilfunknummer) = datenAdresse.mgeschMobilfunknummer
    .txtFields(eAdresse.colEmailadresse) = datenAdresse.mEmailadresse
    .txtFields(eAdresse.colBemerkung) = datenAdresse.mBemerkung
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub AdressDatensatzvor()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmAdressen.grdAdressen
    .Row = .Row + 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
    datenAdresse.mprivFestnetznummer = .TextMatrix(.Row, eAdresse.colprivFestnetznummer)
    datenAdresse.mprivMobilfunknummer = .TextMatrix(.Row, eAdresse.colprivMobilfunknummer)
    datenAdresse.mgeschFestnetznummer = .TextMatrix(.Row, eAdresse.colgeschFestnetznummer)
    datenAdresse.mgeschMobilfunknummer = .TextMatrix(.Row, eAdresse.colgeschMobilfunknummer)
    datenAdresse.mEmailadresse = .TextMatrix(.Row, eAdresse.colEmailadresse)
    datenAdresse.mBemerkung = .TextMatrix(.Row, eAdresse.colBemerkung)
End With

With FrmEingabeAdressen
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
    .txtFields(eAdresse.colprivFestnetznummer) = datenAdresse.mprivFestnetznummer
    .txtFields(eAdresse.colprivMobilfunknummer) = datenAdresse.mprivMobilfunknummer
    .txtFields(eAdresse.colgeschFestnetznummer) = datenAdresse.mgeschFestnetznummer
    .txtFields(eAdresse.colgeschMobilfunknummer) = datenAdresse.mgeschMobilfunknummer
    .txtFields(eAdresse.colEmailadresse) = datenAdresse.mEmailadresse
    .txtFields(eAdresse.colBemerkung) = datenAdresse.mBemerkung
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub LetzterAdressDatensatz()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmAdressen.grdAdressen
    .Row = .Rows - 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
    datenAdresse.mprivFestnetznummer = .TextMatrix(.Row, eAdresse.colprivFestnetznummer)
    datenAdresse.mprivMobilfunknummer = .TextMatrix(.Row, eAdresse.colprivMobilfunknummer)
    datenAdresse.mgeschFestnetznummer = .TextMatrix(.Row, eAdresse.colgeschFestnetznummer)
    datenAdresse.mgeschMobilfunknummer = .TextMatrix(.Row, eAdresse.colgeschMobilfunknummer)
    datenAdresse.mEmailadresse = .TextMatrix(.Row, eAdresse.colEmailadresse)
    datenAdresse.mBemerkung = .TextMatrix(.Row, eAdresse.colBemerkung)
End With

With FrmEingabeAdressen
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
    .txtFields(eAdresse.colprivFestnetznummer) = datenAdresse.mprivFestnetznummer
    .txtFields(eAdresse.colprivMobilfunknummer) = datenAdresse.mprivMobilfunknummer
    .txtFields(eAdresse.colgeschFestnetznummer) = datenAdresse.mgeschFestnetznummer
    .txtFields(eAdresse.colgeschMobilfunknummer) = datenAdresse.mgeschMobilfunknummer
    .txtFields(eAdresse.colEmailadresse) = datenAdresse.mEmailadresse
    .txtFields(eAdresse.colBemerkung) = datenAdresse.mBemerkung
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub AdressDatensatzndern()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmAdressen.grdAdressen
    If IsNumeric(.TextMatrix(.Row, eAdresse.colID)) Then
        datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    Else
        datenAdresse.mAdrID = .Row
    End If
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
    datenAdresse.mprivFestnetznummer = .TextMatrix(.Row, eAdresse.colprivFestnetznummer)
    datenAdresse.mprivMobilfunknummer = .TextMatrix(.Row, eAdresse.colprivMobilfunknummer)
    datenAdresse.mgeschFestnetznummer = .TextMatrix(.Row, eAdresse.colgeschFestnetznummer)
    datenAdresse.mgeschMobilfunknummer = .TextMatrix(.Row, eAdresse.colgeschMobilfunknummer)
    datenAdresse.mEmailadresse = .TextMatrix(.Row, eAdresse.colEmailadresse)
    datenAdresse.mBemerkung = .TextMatrix(.Row, eAdresse.colBemerkung)
End With

With FrmEingabeAdressen
    If IsNumeric(datenAdresse.mAdrID) Then
        .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    Else
        .txtFields(eAdresse.colID) = FrmAdressen.grdAdressen.Row
    End If
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
    .txtFields(eAdresse.colprivFestnetznummer) = datenAdresse.mprivFestnetznummer
    .txtFields(eAdresse.colprivMobilfunknummer) = datenAdresse.mprivMobilfunknummer
    .txtFields(eAdresse.colgeschFestnetznummer) = datenAdresse.mgeschFestnetznummer
    .txtFields(eAdresse.colgeschMobilfunknummer) = datenAdresse.mgeschMobilfunknummer
    .txtFields(eAdresse.colEmailadresse) = datenAdresse.mEmailadresse
    .txtFields(eAdresse.colBemerkung) = datenAdresse.mBemerkung
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub
'******************************************************************************

'********************************************************************
'Serienbriefe
'********************************************************************
Public Sub Serienbriefberschriftensetzen()
On Error GoTo Fehlerbehandlung

    With FrmSerienbrief.grdAdressen
        'Grid leeren
        .Clear
        '1. Reihe mit Spalten anlegen
        .Rows = eAdresse.colID + 1
        .Cols = eAdresse.colBemerkung + 1
        
        'Breiten festlegen
        .ColWidth(eAdresse.colID) = 500
        .ColWidth(eAdresse.colVorname) = 1500
        .ColWidth(eAdresse.colNachname) = 1500
        .ColWidth(eAdresse.colGeburtstag) = 1000
        .ColWidth(eAdresse.colStrasse) = 2000
        .ColWidth(eAdresse.colHausnummer) = 1000
        .ColWidth(eAdresse.colPostleitzahl) = 1000
        .ColWidth(eAdresse.colWohnort) = 1500

        'Beschriften
        .TextMatrix(0, eAdresse.colID) = "ID"
        .TextMatrix(0, eAdresse.colVorname) = "Vorname"
        .TextMatrix(0, eAdresse.colNachname) = "Nachname"
        .TextMatrix(0, eAdresse.colGeburtstag) = "Geburtstag"
        .TextMatrix(0, eAdresse.colStrasse) = "Strae"
        .TextMatrix(0, eAdresse.colHausnummer) = "Haus-Nr"
        .TextMatrix(0, eAdresse.colPostleitzahl) = "PLZ"
        .TextMatrix(0, eAdresse.colWohnort) = "Wohnort"
    End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub ErsterSerienbriefDatensatz()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmSerienbrief.grdAdressen
    .Row = 1
    datenAdresse.mAdrID = .TextMatrix(1, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(1, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(1, eAdresse.colNachname)
    If IsDate(.TextMatrix(1, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(1, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(1, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(1, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(1, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(1, eAdresse.colWohnort)
End With

With FrmSerienbrief
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub SerienbriefDatensatzzurck()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmSerienbrief.grdAdressen
    .Row = .Row - 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
End With

With FrmSerienbrief
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub SerienbriefDatensatzvor()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmSerienbrief.grdAdressen
    .Row = .Row + 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
End With

With FrmSerienbrief
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub LetzterSerienbriefDatensatz()
On Error GoTo Fehlerbehandlung
Dim datenAdresse As mAdresse
    
    
With FrmSerienbrief.grdAdressen
    .Row = .Rows - 1
    datenAdresse.mAdrID = .TextMatrix(.Row, eAdresse.colID)
    datenAdresse.mVorname = .TextMatrix(.Row, eAdresse.colVorname)
    datenAdresse.mNachname = .TextMatrix(.Row, eAdresse.colNachname)
    If IsDate(.TextMatrix(.Row, eAdresse.colGeburtstag)) Then
        datenAdresse.mGeburtstag = .TextMatrix(.Row, eAdresse.colGeburtstag)
    End If
    datenAdresse.mStrasse = .TextMatrix(.Row, eAdresse.colStrasse)
    datenAdresse.mHausnummer = .TextMatrix(.Row, eAdresse.colHausnummer)
    datenAdresse.mPostleitzahl = .TextMatrix(.Row, eAdresse.colPostleitzahl)
    datenAdresse.mWohnort = .TextMatrix(.Row, eAdresse.colWohnort)
End With

With FrmSerienbrief
    .txtFields(eAdresse.colID) = datenAdresse.mAdrID
    .txtFields(eAdresse.colVorname) = datenAdresse.mVorname
    .txtFields(eAdresse.colNachname) = datenAdresse.mNachname
    If IsDate(datenAdresse.mGeburtstag) Then
        .txtFields(eAdresse.colGeburtstag) = datenAdresse.mGeburtstag
    End If
    .txtFields(eAdresse.colStrasse) = datenAdresse.mStrasse
    .txtFields(eAdresse.colHausnummer) = datenAdresse.mHausnummer
    .txtFields(eAdresse.colPostleitzahl) = datenAdresse.mPostleitzahl
    .txtFields(eAdresse.colWohnort) = datenAdresse.mWohnort
End With
    
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub
'******************************************************************************

'-------------------------------------------------------------------
'MSHFlexGrid - Daten aus Datei einlesen und speichern
'-------------------------------------------------------------------

Public Sub LoadAdressenGridData(ByVal vGrid As MSFlexGrid, ByVal _
             vstrFile As String, ByVal vstrSep As String, _
             Optional ByVal nFixedCols As Long = 1, _
             Optional ByVal nFixedRows As Long = 1)

On Error GoTo Fehlerbehandlung

'Daten aus Textdatei einlesen...

    Dim Fn As Integer
  
    Dim astrData As Variant      'Datenfeld
    Dim intCols As Integer        'Datenfeldgre
  
    Dim strTemp As String
  
    Dim r As Long                 'Zeile
    Dim c As Long                 'Spalte

    Fn = FreeFile()
'Datei zum Lesen ffnen...
    Open vstrFile For Input As #Fn
      
      With vGrid
        'Das Neuzeichnen des Grids nach jeder nderung unterbinden:
        '  (Bildschirmflackern vermeiden !!!)
          .Redraw = False
        
        'Zeilen-/Spaltenanzahl im Grid zurcksetzen:
          .Rows = 1
        'Textdatei zeilenweise einlesen...
          Do While Not EOF(Fn)
            Line Input #Fn, strTemp
    
            If Len(strTemp) <> 0 Then
              'Zeile in einzelne Spalten zerlegen:
                astrData = Split(strTemp, vstrSep)
              'Datenfeldgre ermitteln:
                intCols = UBound(astrData)
                
'                MsgBox intCols, vbInformation, "intCols"
                
              'Anzahl der Spalten im Grid  anpassen:
                If intCols + 1 > .Cols Then
                  .Cols = intCols + 1
                End If
                
              'Zeilenanzahl in Grid erhhen:
                .Rows = .Rows + 1
              'Zeile fr nchsten Eintrag festlegen:
                r = .Rows - 1
                
              'Spaltenweise Daten hinzufgen:
                For c = 0 To intCols
                    .TextMatrix(r, c) = astrData(c)
                Next c
            
            Else    'If Len(strTemp) <> 0
            
              'Zeilenanzahl in Grid erhhen:
                .Rows = .Rows + 1
            End If
          Loop
  
        'Grid neu zeichnen:
          .Redraw = True
      End With
  
  'Datei schlieen:
    Close #Fn

bolDatengendert = False

Exit Sub
Fehlerbehandlung:
Call PlayFehlerSound
bolDatengendert = False
DoEvents
MsgBox "Fehler beim Laden der Datei!", vbExclamation, FrmAdressen.Caption
Call PlayClickSound
End Sub

Public Sub SaveAdressenGridData(ByVal vGrid As MSFlexGrid, ByVal _
               vstrFile As String, ByVal vstrSep As String)

On Error GoTo Fehlerbehandlung

'Daten in Textdatei speichern...
    Dim Fn As Integer
    
    Dim nRows As Long    'Anzahl Zeilen
    Dim nCols As Long    'Anzahl Spalten
    
    Dim strTemp As String
    
    Dim r As Long             'Zeile
    Dim c As Long             'Spalte
    
    With vGrid
        nRows = .Rows - 1    'Anzahl Zeilen im Grid
        nCols = .Cols - 1    'Anzahl Spalten im Grid
      
        Fn = FreeFile()
    
      'Datei zum Schreiben ffnen...
        Open vstrFile For Output As #Fn
          'Zeilenweise Spalten lesen und mit Trennzeichen verbinden ...
            For r = 1 To nRows
                strTemp = vbNullString
                For c = 0 To nCols - 1
                    strTemp = strTemp & (.TextMatrix(r, c) & vstrSep)
                Next c
              'Letzte Spalte noch aufnehmen:
                strTemp = strTemp & .TextMatrix(r, c)
              
              '-> Textdatei
                Print #Fn, strTemp
            Next r
      'Datei schlieen:
        Close #Fn
    End With

Dim Msg As String
Msg = "Datei wurde erfolgreich gespeichert"
Call PlayHinweisSound
MsgBox Msg, vbInformation, FrmAdressen.Caption
Call PlayClickSound

Exit Sub
Fehlerbehandlung:
Call PlayHinweisSound
DoEvents
MsgBox "Fehler beim Speichern der Datei!", vbExclamation, FrmAdressen.Caption
Call PlayClickSound
End Sub
'********************************************************************

Public Sub PrintGrid(grid As MSFlexGrid, ByVal LeftMargin As Single, _
              ByVal TopMargin As Single, ByVal RightMargin As _
              Single, ByVal BottomMargin As Single, Titel As _
              String, datum As String, Optional many As Integer)

On Error GoTo Fehlerbehandlung

  Dim tRange As TFormatRange
  Dim lReturn As Long
  Dim DName As String
  Dim DSchacht As Integer
  Dim gbeg As Long
  Dim CopyCW() As Long
  Dim GRef As Boolean
  Dim X%
  
    GRef = False
    If many > 0 Then
      ' Anzahl der zu druckenden Colums festlegen
      ' Alles > many wird auf colwidth = 0 gesetzt
      If grid.Cols > many Then
        gbeg = grid.Cols - many
        ReDim CopyCW(gbeg)
        grid.Redraw = False
        For X = many To grid.Cols - 1
          CopyCW(X - many) = grid.ColWidth(X)
          grid.ColWidth(X) = 0
        Next X
        GRef = True
      End If
    End If
    
    'mit wParam <> 0 kann berprft werden
    'ob das Control OPP untersttzt, wenn ja wird
    '456654 (VP_YESIDO) zurckgeliefert
    lReturn = SendMessage(grid.hwnd, VP_FORMATRANGE, 1, 0)
    
    If lReturn = VP_YESIDO Then
      
      'Struktur mit Formatierungsinformationen fllen
      Printer.ScaleMode = vbPixels
      
'        Einstellungen zum Drucken der Tabelle
'
'        Die Einstellungen fr Wert sind:
'
'        Konstante          Wert    Beschreibung
'        vbPRORPortrait     1       Dokumente werden mit der schmalen Seite _
                                    des Papiers als oberem Rand gedruckt.
'        vbPRORLandscape    2       Dokumente werden mit der breiten Seite _
                                    des Papiers als oberem Rand gedruckt
      Printer.Orientation = PrinterOrientation 'vbPRORLandscape
      
      With tRange
        .hDC = Printer.hDC
        
        'Hhe und Breite einer Seite (in Pixel)
        .rcPage.Right = Printer.ScaleWidth
        .rcPage.Bottom = Printer.ScaleHeight
        
        'Lage und Abmessungen des Bereichs auf den
        'gedruckt werden soll (in Pixel)
        .rc.Left = Printer.ScaleX(LeftMargin, vbMillimeters)
        .rc.Top = Printer.ScaleY(TopMargin, vbMillimeters)
        .rc.Right = .rcPage.Right - Printer.ScaleX(RightMargin, _
                                                   vbMillimeters)
                                                   
        .rc.Bottom = .rcPage.Bottom - Printer.ScaleY(BottomMargin, _
                                                     vbMillimeters)
      End With
  
      'Drucker initialisieren
      Printer.Print vbNullString
      
      'Seite(n) drucken
        Dim i As Integer:    i = 1

      Do
        Printer.CurrentX = Printer.ScaleX(LeftMargin, vbMillimeters)
        Printer.CurrentY = Printer.ScaleY(10, vbMillimeters)
        If Titel <> "" Then Printer.Print Titel
  
        Printer.CurrentX = Printer.ScaleX(LeftMargin, vbMillimeters)
        Printer.CurrentY = Printer.ScaleY(16, vbMillimeters)
        
        If datum <> "" Then
          Printer.Print datum
        Else
          Printer.Print Format(Date, "DD.MM.YYYY")
        End If
        lReturn = SendMessage(grid.hwnd, VP_FORMATRANGE, 0, _
                              VarPtr(tRange))
        'Seitennummer ausdrucken
        Printer.CurrentX = Printer.ScaleWidth - _
                           Printer.TextWidth("Seite " & i & "  ")
                           
        Printer.CurrentY = BottomMargin + (Printer.ScaleHeight - _
                           BottomMargin - Printer.TextHeight("x"))
                           
        Printer.Print "Seite " & i
        
        If lReturn < 0 Then
          Exit Do
        Else
          Printer.NewPage
        End If
        i = i + 1
      Loop
      Printer.EndDoc
  
      'Reset
      lReturn = SendMessage(grid.hwnd, VP_FORMATRANGE, 0, 0)
    End If
    
    If GRef Then
      'Alle Colums wieder in richtiger Breite darstellen
      For X = many To grid.Cols - 1
        grid.ColWidth(X) = CopyCW(X - many)
      Next X
      grid.Redraw = True
    End If

Exit Sub
Fehlerbehandlung:
Call PlayHinweisSound
DoEvents
MsgBox "Fehler beim Drucken der Datei!", vbExclamation, FrmAdressen.Caption
Call PlayClickSound
End Sub

'********************************************************************
'die Anreden einlesen bzw. speichern
'********************************************************************
Public Sub Anredenffnen()
On Error GoTo Fehlerbehandlung

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Anrede
'--------------------------------------------------------------------
If IsFilePath(Laufwerk & "Anredeliste.db") Then
    Anredeliste = Laufwerk & "Anredeliste.db"
    
    iKanalNrAnrede = FreeFile() 'Range Nummer as Integer
    'Einlesen der Eintrge in der Anredeliste
    Open Anredeliste For Input As iKanalNrAnrede
    'Beim ersten Start des Programms ist die Liste noch leer
        If Err.number > 0 Then
        'deshalb Prozedur verlassen
            Exit Sub
        End If
        
        Do While Not EOF(iKanalNrAnrede)
            Line Input #iKanalNrAnrede, stAnredelisteTemp
            FrmSerienbrief.cboAnrede.AddItem stAnredelisteTemp
        Loop
        
    Close iKanalNrAnrede
End If

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub AnredenSchlieen()
On Error GoTo Fehlerbehandlung

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim dr As Drive
Dim drSpeicherLaufwerk As String

    Screen.MousePointer = vbHourglass
'das aktuelle Verzeichnis wird nun im mdlffentlicheVariablen gespeichert
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
Buchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dr In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dr = Buchstabe Then
        Select Case dr.DriveType
            Case Is = CDRom
                drSpeicherLaufwerk = "CD-Rom"
            Case Is = Fixed
                drSpeicherLaufwerk = "Festplatte"
            Case Is = RamDisk
                drSpeicherLaufwerk = "Ram-Disk"
            Case Is = Remote
                drSpeicherLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drSpeicherLaufwerk = "Wechseldatentrger"
            Case Else
                drSpeicherLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
Screen.MousePointer = vbDefault

'der Laufwerkstyp ist nun ermittelt
If dr.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Anrede
'--------------------------------------------------------------------
On Error Resume Next
Anredeliste = Laufwerk & "Anredeliste.db"

iKanalNrAnrede = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von lstAnrede in Anredeliste.db
Open Anredeliste For Output As iKanalNrAnrede
    
   For AnredeNr = 0 To FrmSerienbrief.cboAnrede.ListCount - 1
        Print #iKanalNrAnrede, FrmSerienbrief.cboAnrede.List(AnredeNr)
   Next AnredeNr
   
Close iKanalNrAnrede
End If
    Set fso = Nothing
    Set dr = Nothing

Exit Sub
Fehlerbehandlung:
    Set fso = Nothing
    Set dr = Nothing

Call Fehlermeldung
End Sub

'******************************************************************************
'-------------------------------------------------------------------------------
'--- Die Datenbank reparieren
'-------------------------------------------------------------------------------
Public Sub Datenbankreparieren(ByVal dbFilename As String)
On Error GoTo catch
   
   Dim ar, fs As Variant
   
   Set fs = CreateObject("Scripting.FileSystemObject")
   If fs.FileExists(dbFilename) = True Then
      Screen.MousePointer = 11
      If dbopen = True Then Db.Close
      DBEngine.RepairDatabase (dbFilename)
      Screen.MousePointer = 0
      Call PlayHinweisSound
        MsgBox "Datenbank wurde erfolgreich repariert!", 64, "Reparatur erfolgreich"
'      Call PlayClickSound
   Else
      Call PlayFehlerSound
        MsgBox "Datenbank " & dbFilename & "nicht gefunden!", vbCritical, "Fehler"
'      Call PlayClickSound
   End If
    
    Set fs = Nothing
    
   Exit Sub
catch:
   If Err.number <> 32755 Then
      Call PlayFehlerSound
        MsgBox Err.Description & " (" & Err.number & ")", vbCritical, "Fehler"
      Call PlayClickSound
   End If
   Screen.MousePointer = 0
End Sub

'-------------------------------------------------------------------------------
'--- Die Datenbank komprimieren
'-------------------------------------------------------------------------------
Public Sub Datenbankkomprimieren(ByVal dbFilename As String)
On Error GoTo catch
   Dim quelle
   Dim ar, fs As Variant
   
   
   Set fs = CreateObject("Scripting.FileSystemObject")
   If fs.FileExists(dbFilename) = True Then
      Screen.MousePointer = 11
      quelle = dbFilename
      ar = Split(quelle, ".")
        
      DBEngine.CompactDatabase quelle, ar(0) & ".$$$"
      Kill quelle
      Name ar(0) & ".$$$" As quelle
      Screen.MousePointer = 0
      Call PlayHinweisSound
        MsgBox "Komprimierung wurde erfolgreich abgeschlossen!", 64, "Komprimierung erfolgreich"
      Call PlayClickSound
   Else
      Call PlayFehlerSound
        MsgBox "Datenbank " & dbFilename & " nicht gefunden!", vbCritical, "Fehler"
      Call PlayClickSound
   End If
   
   Set fs = Nothing
   
   Exit Sub
catch:
   If Err.number <> 32755 Then
      Call PlayFehlerSound
      MsgBox Err.Description & " (" & Err.number & ")", vbCritical, "Fehler"
      Call PlayClickSound
   End If
   Screen.MousePointer = 0
End Sub
