Attribute VB_Name = "mdlEditor"
Option Explicit
        
Public Declare Function GetCaretPos Lib "user32" _
        (lpPoint As POINTAPI) As Long
        

Public Declare Function DrawText Lib "user32" Alias _
        "DrawTextA" (ByVal hdc As Long, ByVal lpStr As _
        String, ByVal nCount As Long, lpRect As RECT, _
        ByVal wFormat As Long) As Long
        

'einfrieren und auftauen des Bildschirms
Public Declare Function LockWindowUpdate Lib "user32" _
        (ByVal hwndLock As Long) As Long
        
Public Declare Function GetDesktopWindow Lib "user32" _
        () As Long

Public Declare Function SendMessageLong Lib "user32" Alias _
"SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wparam As Long, _
ByVal lparam As Long) As Long

'API-Funktion zur berprfung der Dateiexistenz
Public Declare Function PathFileExists Lib "shlwapi.dll" _
  Alias "PathFileExistsA" ( _
  ByVal pszPath As String) As Long

Public Declare Function SHGetPathFromIDList Lib "shell32.dll" _
        Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal _
        pszPath As String) As Long
        
Public Declare Function SHGetSpecialFolderLocation Lib _
        "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder _
        As Long, pidl As ITEMIDLIST) As Long
        
Public Declare Function GetTempPath Lib "kernel32" Alias _
        "GetTempPathA" (ByVal nBufferLength As Long, ByVal _
        lpBuffer As String) As Long
        
Public Type itemID
    cb As Long
    abID As Byte
End Type

Public Type ITEMIDLIST
    mkid As itemID
End Type

       
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


' Eigene Bilder
Public Const CSIDL_MYPICTURES As Long = &H27

' Eigene Dateien
Public Const CSIDL_PERSONAL As Long = &H5

Public Const NOERROR As Long = 0&

Public Const LB_ERR = -1
Public Const LB_SETTOPINDEX = &H197  'insure that a particular item is visible
Public Const LB_GETCOUNT = &H18B     'retrieve the number of items in a list box
Public Const LB_GETSEL = &H187       'retrieve the selection state of an item
Public Const LB_ADDSTRING = &H180    'add a string and re-sort a sorted listbox
Public Const LB_INSERTSTRING = &H181 'add a string but do not re-sort a sorted listbox
Public Const LB_DELETESTRING = &H182 'delete a single string
Public Const LB_FINDSTRING = &H18F   'find the first string containing the string specified
Public Const LB_FINDSTRINGEXACT = &H1A2 'find the first string that matches the string specified
Public Const LB_SETTABSTOPS = &H192  'set the tab-stop positions
Public Const LB_RESETCONTENT = &H184 'remove all items
Public Const LB_SETSEL = &H185       'select a string
Public Const LB_GETSELCOUNT = &H190  'retrieve the total number of selected items
Public Const LB_SELECTSTRING = &H18C 'find the first string containing the string specified
Public Const LB_GETCURSEL = &H188    'retrieve the index of the currently selected item
Public Const LB_SETCURSEL = &H186    'select a string and scroll it into view
Public lItem As Long

Public Const DT_CALCRECT = &H400
Public Const SP = 3&

Public Const WM_PAINT = &HF

Public Enum ERECUndoTypeConstants
    ercUID_UNKNOWN = 0
    ercUID_TYPING = 1
    ercUID_DELETE = 2
    ercUID_DRAGDROP = 3
    ercUID_CUT = 4
    ercUID_PASTE = 5
End Enum

Public Enum TextMode
    TM_PLAINTEXT = 1
    TM_RICHTEXT = 2 ' /* default behavior */
    TM_SINGLELEVELUNDO = 4
    TM_MULTILEVELUNDO = 8 ' /* default behavior */
    TM_SINGLECODEPAGE = 16
    TM_MULTICODEPAGE = 32 ' /* default behavior */
End Enum

Public Const EM_SETTEXTMODE = (WM_USER + 89)
Public Const EM_UNDO = &HC7
Public Const EM_REDO = (WM_USER + 84)
Public Const EM_CANUNDO = &HC6&
Public Const EM_CANREDO = (WM_USER + 85)
Public Const EM_GETUNDONAME = (WM_USER + 86)
Public Const EM_GETREDONAME = (WM_USER + 87)

Private Const EM_CHARFROMPOS As Long = &HD7&

'Private Type POINTAPI
'    x As Long
'    y As Long
'End Type

Private Sign(255) As Integer

'Speicher-Variablen zum Erstellen der notwendigen Dateien
Private IntellisenseBoxEintrge As String
'die Namen werden in IntellisenseBoxEintrge.db gespeichert
Dim stIntellisenseBoxEintrgeTemp As String
Dim iKanalNrIntellisenseBox As Integer
Dim IntellisenseBoxNr As Integer

Public Const strFilter As String = _
"Rich Text Format (*.RTF)|*.rtf|Text Dateien (*.txt)|*.txt|Word Dateien (*.doc)|*.doc|alle Dateien *.*|*.*"

Public Const strSpeicherFilter As String = _
"Rich Text Format (*.RTF)|*.rtf|Text Dateien (*.txt)|*.txt|Word Dateien (*.doc)|*.doc|PDF Datei (*.pdf)|*.pdf|alle Dateien *.*|*.*"
'>> FilterIndex 1 <<           | >> FilterIndex 2 <<      | >> FilterIndex 3 <<      | >> FilterIndex 4 <<   | >> FilterIndex 5 <<      |

Public InitPfad As String       'InitDir fr CommonDialog
Public Verndert As Boolean     'Dateinderung
Public bGendert As Boolean     'fr IntellisenseBoxnderung

Public Ladevorgang As Boolean
Public strfileName As String
Public i As Long
Public Laufwerk As String

' Bentigte API-Deklarationen
Private Declare Function GetClassLong Lib "user32" _
  Alias "GetClassLongA" ( _
  ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetClassLong Lib "user32" _
  Alias "SetClassLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long) As Long

Private Const GCL_STYLE = (-26)
Private Const CS_DROPSHADOW = &H20000

'Speicher-Variablen zum Erstellen der notwendigen Dateien
Public Fileliste As String
'die File werden in Fileliste.db gespeichert
Dim stFilelisteTemp As String
Dim iKanalNrFile As Integer
Dim FileNr As Integer

Public Sub RTFInfosanzeigen()
On Error GoTo Fehlerbehandlung

  Dim lnghWnd As Long
  Dim lngCursorPos As Long
  Dim lngLineIndex As Long
  Dim lngFirstCharPos As Long
  Dim lngLineLength As Long
  Dim abytBuffer() As Byte
  Dim strRetVal As String
  
  lnghWnd = FrmEditor.RichTextBox1.hwnd

  'Cursor-Position ermitteln:
  lngCursorPos = SendMessage(lnghWnd, EM_GETSEL, _
        0, ByVal 0&) \ &H10000
    'frmeditor.mnuPos.Caption = "Cursor-pos : " & lngCursorPos & "    "
    
  'Zeilen-Index ermitteln:
  lngLineIndex = SendMessage(lnghWnd, EM_LINEFROMCHAR, _
        lngCursorPos, ByVal 0&)
    FrmEditor.StatusBar1.Panels(2).Text = "Zeile : " & lngLineIndex + 1 & "    "
    
  'Position des erstens Zeichens in Zeile ermitteln:
  lngFirstCharPos = SendMessage(lnghWnd, EM_LINEINDEX, _
        lngLineIndex, ByVal 0&)
    
  'Anzahl Zeichen in Zeile ermitteln:
  lngLineLength = SendMessage(lnghWnd, EM_LINELENGTH, _
        lngFirstCharPos, ByVal 0&)
    FrmEditor.StatusBar1.Panels(3).Text = "Anzahl Zeichen : " & lngLineLength

  'Anzahl Zeilen ermitteln:
    Dim Zeilen As Long
    
    If Len(FrmEditor.RichTextBox1.Text) > 0 Then
        Zeilen = SendMessage(lnghWnd, EM_GETLINECOUNT, 0&, ByVal 0&)
        FrmEditor.StatusBar1.Panels(4).Text = "ges. Zeile/n  " & CStr(Zeilen)
    Else
        FrmEditor.StatusBar1.Panels(4).Text = "Kein Text vorhanden."
    End If
    
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub CreateBackImage(ByRef RTB As RichTextBox, ByRef pb As PictureBox, _
                                                 ByVal savePath As String)

    With RTB
        pb.AutoRedraw = True
        pb.Move 0, 0, .Width, .Height
        SendMessage .hwnd, WM_PAINT, pb.hdc, ByVal 0&
        SavePicture pb.Image, savePath
    End With
End Sub

' Fenster mit zustzlichem Schatten ausstatten
Public Sub SetWindowShadow(ByVal hwnd As Long)
  Call SetClassLong(hwnd, GCL_STYLE, GetClassLong(hwnd, GCL_STYLE) Or CS_DROPSHADOW)
End Sub

Public Sub ZeileMarkieren(RTB As RichTextBox)
        
  Dim lngCursorPos As Long
  Dim lngLineIndex As Long
  Dim lngFirstCharPos As Long
  Dim lngLineLength As Long

FrmEditor.Timer1.Enabled = False
  'Cursor-Position ermitteln:
  lngCursorPos = SendMessage(RTB.hwnd, EM_GETSEL, _
        0, ByVal 0&) \ &H10000

  'Zeilen-Index ermitteln:
  lngLineIndex = SendMessage(RTB.hwnd, EM_LINEFROMCHAR, _
        lngCursorPos, ByVal 0&)

  'Position des erstens Zeichens in Zeile ermitteln:
  lngFirstCharPos = SendMessage(RTB.hwnd, EM_LINEINDEX, _
        lngLineIndex, ByVal 0&)

  'Anzahl Zeichen in Zeile ermitteln:
  lngLineLength = SendMessage(RTB.hwnd, EM_LINELENGTH, _
        lngFirstCharPos, ByVal 0&)

RTB.SelStart = SendMessage(RTB.hwnd, EM_LINEINDEX, lngLineIndex, 0)
RTB.SelLength = SendMessage(RTB.hwnd, EM_LINELENGTH, lngFirstCharPos, 0)

FrmEditor.Timer1.Enabled = True
'Syntax:
'ZeileMarkieren [RichTextBox]
'
'Beispiel:
'ZeileMarkieren Form1.RichTextBox1
End Sub

Public Function GetLineText(ByVal Line As Long) As String
On Error GoTo Fehlerbehandlung
'diese Funktion ist besser, da sie die sichtbaren Zeilenumbrche auch so bernimmt

Dim Buffer() As Byte
Dim LineText As String
Dim lngFirstCharPos As Long
Dim lngLineLength As Long
    
  'Position des erstens Zeichens in Zeile ermitteln:
  lngFirstCharPos = SendMessage(FrmEditor.RichTextBox1.hwnd, EM_LINEINDEX, _
        Line, ByVal 0&)
    
  'Anzahl Zeichen in Zeile ermitteln:
  lngLineLength = SendMessage(FrmEditor.RichTextBox1.hwnd, EM_LINELENGTH, _
        lngFirstCharPos, ByVal 0&)

ReDim Buffer(lngLineLength + 1)
Buffer(0) = lngLineLength + 1

SendMessage FrmEditor.RichTextBox1.hwnd, EM_GETLINE, Line, Buffer(0)
LineText = Left$(StrConv(Buffer, vbUnicode), lngLineLength)

        GetLineText = LineText
    
Exit Function
Fehlerbehandlung:

End Function

Public Sub Fehlermeldung()
Call Defrost
Screen.MousePointer = vbDefault
Call PlayFehlerSound
    MsgBox "Fehler : " & Err.number & Chr(13) & Err.Description & "," & Chr(13) & Chr(13) _
    & "du kannst dennoch eingeschrnkt oder auch uneingeschrnkt weitermachen !", _
    vbCritical, App.EXEName & " : Ein Fehler ist aufgetreten !"
End Sub

Public Sub Freeze()
'Fenster einfrieren
  LockWindowUpdate (GetDesktopWindow)
End Sub

Public Sub Defrost()
'Fenster wieder normal anzeigen
  LockWindowUpdate (0&)
End Sub

Public Function GetPath(ByVal hwnd As Long, Num As Long) As String
    Dim Result As Long
    Dim Buff As String
    Dim idl As ITEMIDLIST
   
    Result = SHGetSpecialFolderLocation(hwnd, Num, idl)
    If Result = NOERROR Then
        Buff = Space$(512)
        Result = SHGetPathFromIDList(ByVal idl.mkid.cb, ByVal Buff)
        If Result Then GetPath = Trim$(Buff)
    End If
End Function

' Aufruf der API
Public Function IsFilePath(strPath As String) As Boolean
  IsFilePath = CBool(PathFileExists(strPath))
End Function

Public Sub GetWordfileContent(ByVal Filename As String, ByRef outControl As RichTextBox)
    Dim lPos            As Long
    Dim First           As Long
    Dim wa              As Object
    Dim FileContent     As String
    
On Error GoTo Fehlerbehandlung

Screen.MousePointer = 13
Call Freeze

    Set wa = CreateObject("Word.Application")
    '
    With wa
        .Visible = False
        .Documents.Open Filename, , True
        .WordBasic.EditSelectAll
        .WordBasic.SetDocumentVar "Test", .WordBasic.Selection
        FileContent = .WordBasic.GetDocumentVar("Test")
        lPos = 1
        Do While lPos < Len(FileContent)
            First = InStr(lPos, FileContent, vbCr)
            If First = 0 Then Exit Do
            FileContent = Left(FileContent, First - 1) & vbCrLf & _
                                            Mid(FileContent, First + 1)
            lPos = First + 2
        Loop
        outControl = FileContent
        .Documents.Close (0)
        .Quit
    End With
    Set wa = Nothing

Call Defrost
Screen.MousePointer = vbDefault

Exit Sub
Fehlerbehandlung:
Call Defrost
   Call Fehlermeldung
End Sub

Public Sub EditCopyProc()
On Error GoTo Fehlerbehandlung

With FrmEditor
    With .RichTextBox1
        If .SelLength <> 0 Then
            ' Kopieren des ausgewhlten Textes in die Zwischenablage.
            Clipboard.SetText .SelText
        Else
            MsgBox "Es wurde kein Text markiert !", vbInformation, "Text kopieren"
        End If
    End With
End With

Exit Sub
Fehlerbehandlung:
    Call Fehlermeldung
End Sub

Public Sub EditCutProc()
On Error GoTo Fehlerbehandlung

With FrmEditor.RichTextBox1
    If .SelLength <> 0 Then
        ' Kopieren des ausgewhlten Textes in die Zwischenablage.
        Clipboard.SetText .SelText
        ' Lschen des ausgewhlten Textes.
        .SelText = ""
    Else
        MsgBox "Es wurde kein Text markiert !", vbInformation, "Text ausschneiden"
    End If
End With

Exit Sub
Fehlerbehandlung:
    Call Fehlermeldung
End Sub

Public Sub EditPasteProc()
On Error GoTo Fehlerbehandlung

With FrmEditor.RichTextBox1
    ' Einfgen des Textes aus der Zwischenablage im aktuellen Steuerelement.
    .SelText = Clipboard.GetText()
End With

Exit Sub
Fehlerbehandlung:
    Call Fehlermeldung
End Sub

Public Sub IntellisenseBoxDateiffnen(ByVal frm As Form)
On Error GoTo Fehlerbehandlung

    frm.lstIntellisenseBox.Clear

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen IntellisenseBoxdateen
'--------------------------------------------------------------------
If IsFilePath(Laufwerk & "IntellisenseBox.db") Then
    IntellisenseBoxEintrge = Laufwerk & "IntellisenseBox.db"
    
    Screen.MousePointer = 13
    
    iKanalNrIntellisenseBox = FreeFile() 'Range Nummer as Integer
    'Einlesen der Eintrge in der IntellisenseBoxEintrge
    Open IntellisenseBoxEintrge For Input As iKanalNrIntellisenseBox
    'Beim ersten Start des Programms ist die Liste noch leer
        If Err.number > 0 Then
        'deshalb Prozedur verlassen
            Exit Sub
        End If
        
        With frm
            'bewirkt ein deutlich schnelleres einlesen
            .lstIntellisenseBox.Visible = False
        
            Do While Not EOF(iKanalNrIntellisenseBox)
                Line Input #iKanalNrIntellisenseBox, stIntellisenseBoxEintrgeTemp
                    .lstIntellisenseBox.AddItem stIntellisenseBoxEintrgeTemp
                'MsgBox stIntellisenseBoxEintrgeTemp
            Loop
            If .Name <> "FrmEditor" Then
                .lstIntellisenseBox.Visible = True
                .lblAnzahl.Caption = "Anzahl Eintrge : " & .lstIntellisenseBox.ListCount
            End If
        End With
        
    Close iKanalNrIntellisenseBox
    
    Screen.MousePointer = vbDefault
    
    With frm.lstIntellisenseBox
        If .ListCount > 0 Then
            MsgBox .ListCount & " Eintrge wurden geladen !", vbInformation, "Wrterbuch geladen"
        Else
            MsgBox "Es wurden (noch) keine Eintrge gefunden !", vbInformation, "Wrterbuch"
        End If
    End With
    
End If

Exit Sub
Fehlerbehandlung:
    Call Fehlermeldung
End Sub

Public Sub externeIntellisenseBoxDateiffnen(ByVal frm As Form)
On Error GoTo Abbruch:

Call PlayFensterffnenSound

With frm.CommonDialog1
    .DialogTitle = "Datei ffnen"
    If InitPfad = "" Then
        .InitDir = GetPath(frm.hwnd, CSIDL_PERSONAL)
    Else
        .InitDir = InitPfad
    End If
    .CancelError = True
    .Flags = cdlOFNFileMustExist
    .Filter = "Datenbankdateien *.db|*.db"
    .ShowOpen
        DoEvents
    If .Filename > "" Then

        InitPfad = frm.CommonDialog1.InitDir
        
        frm.lstIntellisenseBox.Clear
        
        '--------------------------------------------------------------------
        'ffnen und einlesen der vorhandenen IntellisenseBoxdateen
        '--------------------------------------------------------------------
        If IsFilePath(.Filename) Then
            IntellisenseBoxEintrge = .Filename
            
            Screen.MousePointer = 13
            
            iKanalNrIntellisenseBox = FreeFile() 'Range Nummer as Integer
            'Einlesen der Eintrge in der IntellisenseBoxEintrge
            Open IntellisenseBoxEintrge For Input As iKanalNrIntellisenseBox
            'Beim ersten Start des Programms ist die Liste noch leer
                If Err.number > 0 Then
                'deshalb Prozedur verlassen
                    Exit Sub
                End If
                
                frm.lstIntellisenseBox.Visible = False
                
                Do While Not EOF(iKanalNrIntellisenseBox)
                    Line Input #iKanalNrIntellisenseBox, stIntellisenseBoxEintrgeTemp
                    With frm
                        .lstIntellisenseBox.AddItem stIntellisenseBoxEintrgeTemp
                        If frm.Name = "FrmEditor" Then
                            FrmWrterbuch.lstIntellisenseBox.AddItem stIntellisenseBoxEintrgeTemp
                        End If
                    End With
                    'MsgBox stIntellisenseBoxEintrgeTemp
                Loop
                
                If frm.Name <> "FrmEditor" Then
                    frm.lstIntellisenseBox.Visible = True
                    frm.lblAnzahl.Caption = "Anzahl Eintrge : " & frm.lstIntellisenseBox.ListCount
                End If
                
            Close iKanalNrIntellisenseBox
            
            Screen.MousePointer = vbDefault
    
            With frm.lstIntellisenseBox
                If .ListCount > 0 Then
                    MsgBox .ListCount & " Eintrge wurden geladen !", vbInformation, "Wrterbuch geladen"
                        If frm.Name = "FrmEditor" Then
                            FrmWrterbuch.Show vbModal
                        End If
                Else
                    MsgBox "Es wurden (noch) keine Eintrge gefunden !", vbInformation, "Wrterbuch"
                End If
            End With

        End If
    End If
End With
Exit Sub
Abbruch:
    If Err.number <> 32755 Then
        Call Fehlermeldung
    End If
End Sub

Public Sub IntellisenseBoxDateiSchlieen(ByVal frm As Form)
On Error GoTo Fehlerbehandlung
Dim drLaufwerksbuchstabe As String
Dim drLaufwerk As String
Dim fso As New FileSystemObject
Dim dR As Drive
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
drLaufwerksbuchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dR In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dR = drLaufwerksbuchstabe Then
        Select Case dR.DriveType
            Case Is = CDRom
                drLaufwerk = "CD-Rom"
            Case Is = Fixed
                drLaufwerk = "Festplatte"
            Case Is = RamDisk
                drLaufwerk = "Ram-Disk"
            Case Is = Remote
                drLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drLaufwerk = "Wechseldatentrger"
            Case Else
                drLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
        'drLaufwerk, der Laufwerkstyp ist nun ermittelt _
        und wird nun im mdlffentlicheVariablen gespeichert

If dR.DriveType <> CDRom Then
    '--------------------------------------------------------------------
    'ffnen und schreiben der vorhandenen IntellisenseBoxdaten
    '--------------------------------------------------------------------
    
    Screen.MousePointer = 13
    
    IntellisenseBoxEintrge = Laufwerk & "IntellisenseBox.db"
    
    With frm.lstIntellisenseBox
    
        iKanalNrIntellisenseBox = FreeFile() 'Range Nummer as Integer
        'schreiben der Eintrge von lstNamen in Namenliste.db
        Open IntellisenseBoxEintrge For Output As iKanalNrIntellisenseBox
                
            For IntellisenseBoxNr = 0 To .ListCount - 1
                 Print #iKanalNrIntellisenseBox, .List(IntellisenseBoxNr)
            Next IntellisenseBoxNr
        
        Close iKanalNrIntellisenseBox
    
    End With
    
    Screen.MousePointer = vbDefault
    
    MsgBox "Daten wurden gespeichert !", vbInformation, "gespeichert"
    bGendert = False
    
Set fso = Nothing
Set dR = Nothing

Else
    bGendert = False
    Exit Sub
End If

Exit Sub
Fehlerbehandlung:
Set fso = Nothing
Set dR = Nothing
Call Fehlermeldung
End Sub

Public Sub IntellisenseBoxspeichernunter(ByVal frm As Form)
On Error GoTo Fehlerbehandlung

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim drDatei As Drive
Dim drSpeicherLaufwerk As String

With frm.CommonDialog1
    .DialogTitle = "Speichern unter..."
        If InitPfad = "" Then
            .InitDir = GetPath(frm.hwnd, CSIDL_PERSONAL)
        Else
            .InitDir = InitPfad
        End If
    .Filter = "Datenbankdateien *.db|*.db"
    'bei gleicher Namensgebung mu besttigt werden
    .Flags = cdlOFNOverwritePrompt
    .CancelError = True
    .ShowSave
    If Len(.Filename) = 0 Then
        Exit Sub
    End If
    
    'Angegebene Datei im RTF-Format speichern
        
    Screen.MousePointer = vbHourglass
    'das aktuelle Verzeichnis wird nun im mdlffentlicheVariablen gespeichert
    'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
    Buchstabe = Left(.Filename, 2)
    
    'bei nicht betriebsbereitem Laufwerk
    On Error Resume Next
    
    For Each drDatei In fso.Drives
        'Laufwerksbuchstaben einsetzen
        'den Laufwerkstyp ermitteln
        If drDatei = Buchstabe Then
            Select Case drDatei.DriveType
                Case Is = CDRom
                    drSpeicherLaufwerk = "CD-Rom"
                Case Is = Fixed
                    drSpeicherLaufwerk = "Festplatte"
                Case Is = RamDisk
                    drSpeicherLaufwerk = "Ram-Disk"
                Case Is = Remote
                    drSpeicherLaufwerk = "Netzlaufwerk"
                Case Is = Removable
                    drSpeicherLaufwerk = "Wechseldatentrger"
                Case Else
                    drSpeicherLaufwerk = "Unbekannt"
            End Select
        'wenn gefunden Schleife verlassen
        Exit For
        End If
    Next
    Screen.MousePointer = vbDefault
            'drLaufwerk, der Laufwerkstyp ist nun ermittelt _
            und wird nun im mdlffentlicheVariablen gespeichert
    If drDatei.DriveType <> CDRom Then

        InitPfad = frm.CommonDialog1.InitDir
        
        '--------------------------------------------------------------------
        'ffnen und schreiben der vorhandenen IntellisenseBoxdaten
        '--------------------------------------------------------------------
        
        Screen.MousePointer = 13
        
        IntellisenseBoxEintrge = .Filename
        
        With frm.lstIntellisenseBox
        
            iKanalNrIntellisenseBox = FreeFile() 'Range Nummer as Integer
            'schreiben der Eintrge von lstNamen in Namenliste.db
            Open IntellisenseBoxEintrge For Output As iKanalNrIntellisenseBox
                    
                For IntellisenseBoxNr = 0 To .ListCount - 1
                     Print #iKanalNrIntellisenseBox, .List(IntellisenseBoxNr)
                Next IntellisenseBoxNr
            
            Close iKanalNrIntellisenseBox
        
        End With

            Screen.MousePointer = vbDefault
            
            MsgBox "Daten wurden gespeichert !", vbInformation, "gespeichert"
            bGendert = False
        
        Set fso = Nothing
        Set drDatei = Nothing

    Else
        bGendert = False
        Exit Sub
    End If
End With

Exit Sub
Fehlerbehandlung:
Set fso = Nothing
Set drDatei = Nothing
    If Err.number <> 32755 Then
        Fehlermeldung
    End If
End Sub
'
''den Inhalt zerlegen
'Private Sub zerlegeSatz(ByVal Satz As String, Wort() As String)
'Dim Position As Long
'Dim Zeichen As Long
'Dim zaehler As Long
'Dim Text As String
'
'Screen.MousePointer = 13
'For Zeichen = 1 To Len(Satz)
'    If Mid$(Satz, Zeichen, 1) = Space$(1) Then
'        Position = Position + 1
'    End If
'Next Zeichen
'
'ReDim Wort(Position + 1)
'
'For Zeichen = 1 To Len(Satz)
'    Text = Mid$(Satz, Zeichen, 1)
''            MsgBox Text, vbInformation, "Text in ZerlegeSatz"
'        If Text <> Space$(1) Then
'            If InStr(1, Text, ".", vbTextCompare) _
'            Or InStr(1, Text, "!", vbTextCompare) _
'            Or InStr(1, Text, ",", vbTextCompare) _
'            Or InStr(1, Text, ":", vbTextCompare) _
'            Or InStr(1, Text, "?", vbTextCompare) _
'            Or InStr(1, Text, ";", vbTextCompare) _
'            Or InStr(1, Text, "-", vbTextCompare) _
'            Or InStr(1, Text, "_", vbTextCompare) _
'            Or InStr(1, Text, "", vbTextCompare) _
'            Or InStr(1, Text, "%", vbTextCompare) _
'            Or InStr(1, Text, "$", vbTextCompare) _
'            Or InStr(1, Text, "&", vbTextCompare) _
'            Or InStr(1, Text, "/", vbTextCompare) _
'            Or InStr(1, Text, "(", vbTextCompare) _
'            Or InStr(1, Text, ")", vbTextCompare) _
'            Or InStr(1, Text, "=", vbTextCompare) _
'            Or InStr(1, Text, "<", vbTextCompare) _
'            Or InStr(1, Text, ">", vbTextCompare) _
'            Or InStr(1, Text, "+", vbTextCompare) _
'            Or InStr(1, Text, "*", vbTextCompare) _
'            Or InStr(1, Text, "~", vbTextCompare) _
'            Or InStr(1, Text, "", vbTextCompare) _
'            Or InStr(1, Text, "#", vbTextCompare) _
'            Or InStr(1, Text, "^", vbTextCompare) _
'            Or IsNumeric(Text) Then
'                'keine Sonderzeichen oder Nummern zulassen
'            Else
'                Wort(zaehler) = Wort(zaehler) & Text
'            End If
'        Else
'            zaehler = zaehler + 1
'        End If
'Next Zeichen
''    MsgBox Wort(zaehler), vbInformation, "in zerlege satz"
'Screen.MousePointer = vbDefault
'End Sub

Public Function GetTrueWord(WrongWord As String) As String
On Error GoTo Fehlerbehandlung

'  Dim TmpASCII  As Long, str As String, StrLen As Long

If Len(WrongWord) > 1 Then
'alte Functions-Routiene verursacht keinen Laufzeitfehler, _
dafr knnen aber "ungltige" Zeichen u.U. erhalten bleiben
'******************************************************************************
'str = WrongWord
'
'  TmpASCII = Asc(Right$(str, 1))
'  StrLen = Len(str)
'
'  Select Case TmpASCII
'    ' bei a -z, a - z, 0 - 9, , , , , ,  nichts tun
'    Case 65 To 90, 47 To 122, 48 To 57, 228, 196, 246, 214, 252, 220, 223
'      GetTrueWord = str
'    ' bei anderen Zeichen letztes Zeichen entfernen
'    Case Else
'      GetTrueWord = Left$(str, StrLen - 1)
'      str = Left$(str, StrLen - 1)
'  End Select
'
'    If Len(str) > 1 Then
'          TmpASCII = Asc(Left$(str, 1))
'          StrLen = Len(str)
'
'          Select Case TmpASCII
'            ' bei a -z, a - z, 0 - 9, , , , , ,  nichts tun
'            Case 65 To 90, 47 To 122, 48 To 57, 228, 196, 246, 214, 252, 220, 223
'              GetTrueWord = str
'            ' bei anderen Zeichen letztes Zeichen entfernen
'            Case Else
'              GetTrueWord = Right$(str, StrLen - 1)
'          End Select
'    End If
'******************************************************************************

'******************************************************************************
'neue Functions-Routiene lscht zwar alle "ungltigen" Zeichen, _
verursacht aber ab einem bestimmten Punkt einen Laufzeitfehler

Dim str As String
str = ""
For i = 1 To Len(WrongWord)
    If i < Len(WrongWord) Then
        Select Case Asc(Mid(WrongWord, i, 1))
                ' bei a -z, a - z,Komma,Punkt, 0 - 9, , , , , ,  nichts tun
            Case 65 To 90, 47 To 122, 44, 46, 48 To 57, 228, 196, 246, 214, 252, 220, 223
                str = str & Mid(WrongWord, i, 1)
            Case Else
                Mid(WrongWord, i, 1) = ""
                str = str
        End Select
    Else    'Wortende
        Select Case Asc(Mid(WrongWord, i, 1))
                ' bei a -z, a - z, 0 - 9, , , , , ,  nichts tun
            Case 65 To 90, 47 To 122, 48 To 57, 228, 196, 246, 214, 252, 220, 223
                str = str & Mid(WrongWord, i, 1)
            Case Else
                Mid(WrongWord, i, 1) = ""
                str = str
        End Select
    End If
Next
    GetTrueWord = str
'******************************************************************************
End If

Exit Function
Fehlerbehandlung:
End Function


Public Sub WorteinIntellisenseBoxeinfgen()
'ReDim woerter(2) As String
Dim x As Long
Dim n As Long

'Call zerlegeSatz(FrmEditor.RichTextBox1.Text, woerter())
    Dim arrWords() As String, Text As String
    Dim WrongWord As String
With FrmEditor
    If .RichTextBox1.SelLength = 0 Then
        Text = Replace(FrmEditor.RichTextBox1.Text, vbCrLf, " ")
    Else
        Text = Replace(FrmEditor.RichTextBox1.SelText, vbCrLf, " ")
    End If
        Text = Replace(Text, vbLf, " ")
        Text = Replace(Text, vbCr, " ")
        arrWords = Split(Text, " ")
    
    .txtProgress.Visible = True
    .ProgBar.Visible = True
    .ProgBar.Min = 0
    .ProgBar.max = UBound(arrWords) + 1
  
    If .lstIntellisenseBox.ListCount > 0 Then
        If MsgBox("Es sind bereits Eintrge im Wrterbuch vorhanden !" & vbCrLf _
        & "Sollen diese gelscht und durch die neuen Eintrge ersetzt werden ?" _
        , vbQuestion + vbDefaultButton2 + vbYesNo, "Wrterbuch lschen") = vbYes Then
            .lstIntellisenseBox.Clear
            bGendert = True
        End If
    End If
    
    Screen.MousePointer = 13
    'Dieser Text wird, nachdem das Men "ganzen Text in Wrterbuch bernehmen" bettigt wurde, _
    in die Intellisensebox bertragen, wobei die einzelnen Wrter zerlegt werden !
    
    For x = 0 To UBound(arrWords)
        With .lstIntellisenseBox
            Dim bVorhanden As Boolean
            bVorhanden = False
            If Len(arrWords(x)) > 1 Then
                WrongWord = GetTrueWord(arrWords(x))
                arrWords(x) = WrongWord
                'prfen ob doppelte Eintrge zugelassen werden sollen
                If FrmEditor.mnuDoppeltEintrag.Checked = False Then
        '            MsgBox woerter(X), vbInformation, "woerter(x)"
                    For n = 0 To .ListCount - 1
                        If StrConv(.List(n), vbLowerCase) <> StrConv(arrWords(x), vbLowerCase) Then
                            bVorhanden = False
                        Else
                            bVorhanden = True
                            Exit For
                        End If
                    Next
                    
                    If bVorhanden = False Then
                        If Trim(arrWords(x)) <> "" Then
                            .AddItem Trim(arrWords(x))
                            bGendert = True
                        End If
                    End If
                Else
                    If Trim(arrWords(x)) <> "" Then
                        .AddItem Trim(arrWords(x))
                        bGendert = True
                    End If
                End If
            End If
        End With
    
        .ProgBar.Value = x + 1
        .txtProgress.Text = _
          Format(.ProgBar.Value / .ProgBar.max * 100, "##") & " %"
        DoEvents
    Next x
    
    Screen.MousePointer = vbDefault
    
    .ProgBar.Visible = False
    .txtProgress.Visible = False
    MsgBox "Anzahl der Eintrge : " & FrmEditor.lstIntellisenseBox.ListCount, _
    vbInformation, "Eintrge sind nun vorhanden"
End With
End Sub

Public Function WriteGramSentenceUCase(ByVal Source As String) As String
On Error GoTo Fehlerbehandlung
'alle Satzanfnge gro schreiben
    If Len(Source) = 0 Then
        Call MsgBox("Es ist kein Text zum ndern vorhanden!", vbInformation, "Info...")
        Exit Function
    Else
        Const Seperator As String = "?!."
        Mid(Source, 1, 1) = UCase(Mid(Source, 1, 1))
        Dim CharCount   As Long
        Dim n           As Long
        
        For CharCount = 2 To Len(Source) - 1
            
            n = InStr(Seperator, Mid(Source, CharCount, 1))
            If n > 0 Then
                While Mid(Source, CharCount + 1, 1) = " "
                    CharCount = CharCount + 1
                Wend
                While Mid(Source, CharCount + 1, 2) = vbCrLf
                    CharCount = CharCount + 2
                Wend
                On Error Resume Next    'Letzte Zeile vbCrLf ???
                Mid(Source, CharCount + 1, 1) = UCase(Mid(Source, CharCount + 1, 1))
            End If
        Next
        WriteGramSentenceUCase = Source
    End If
Exit Function
Fehlerbehandlung:
Call Fehlermeldung
End Function

Public Function CountWords(ByRef rtfCtrl As RichTextBox) As Long
'Beispiel : Worte in RichTextBox zaehlen.
'Hinweis  : Als Trennzeichen gilt ein Leerzeichen.
'
    Dim nCount      As Long
    Dim Position    As Long
    Dim tmpPos      As Long
    
    nCount = 0
    tmpPos = 0
    
    With rtfCtrl
        Position = InStr(.Text, " ")
        Do While Position > 0
            If Mid$(.Text, Position - 1, 1) <> " " Then nCount = nCount + 1
            tmpPos = Position
            Position = InStr(Position + 1, .Text, " ")
        Loop
        If tmpPos < Len(.Text) Then nCount = nCount + 1
        CountWords = nCount
    End With
End Function

Sub InitSigns()
    Dim i As Long
    Dim k As Long
    Dim Test As String
    
    Test = ".,;:?!"
    For i = 1 To Len(Test)
        k = Asc(Mid$(Test, i, 1))
        Sign(k) = 1
    Next i
    
    Test = " " + vbCrLf + Chr$(160)
    For i = 1 To Len(Test)
        k = Asc(Mid$(Test, i, 1))
        Sign(k) = 2
    Next i
End Sub

Public Function GetWord(Rich As RichTextBox, ByVal x&, ByVal y&) As String
On Error GoTo Fehlerbehandlung

    Dim pos As Long, P1 As Long, P2 As Long
    Dim Char As Long
    Dim MousePointer As POINTAPI
    
    ' Position des Textzeichens unter dem Mauszeiger auslesen.
    MousePointer.x = x \ Screen.TwipsPerPixelX
    MousePointer.y = y \ Screen.TwipsPerPixelY
    pos = SendMessage(Rich.hwnd, EM_CHARFROMPOS, 0&, MousePointer)
    If pos <= 0 Then Exit Function
    
    ' Wortanfang finden.
    For P1 = pos To 1 Step -1
        Char = Asc(Mid$(Rich.Text, P1, 1))
        If Sign(Char) = 2 Then
            Exit For
        End If
    Next P1
    P1 = P1 + 1
    
    ' Wortende finden.
    For P2 = pos To Len(Rich.Text)
        Char = Asc(Mid$(Rich.Text, P2, 1))
        If Sign(Char) = 2 Then
            Exit For
        End If
    Next P2
    P2 = P2 - 1
    
    If P1 < P2 Then GetWord = Mid$(Rich.Text, P1, P2 - P1 + 1)

Exit Function
Fehlerbehandlung:
End Function

Public Function FileNamekrzen(ByVal strFile As String) As String
    'Dateinamen krzen
Dim Dateinamekurz As String
Dateinamekurz = Mid(strFile, InStrRev(strFile, "\") + 1)
    FileNamekrzen = Dateinamekurz
End Function

'********************************************************************
'die Dateien einlesen bzw. speichern
'********************************************************************
Public Sub Dokumenteffnen()
On Error GoTo Fehlerbehandlung

'--------------------------------------------------------------------
'ffnen und einlesen der zuvor geffneten Dokumente
'--------------------------------------------------------------------
If IsFilePath(Laufwerk & "Fileliste.db") Then
    Fileliste = Laufwerk & "Fileliste.db"
    
    iKanalNrFile = FreeFile() 'Range Nummer as Integer
    'Einlesen der Eintrge in der Fileliste
    Open Fileliste For Input As iKanalNrFile
    'Beim ersten Start des Programms ist die Liste noch leer
        If Err.number > 0 Then
        'deshalb Prozedur verlassen
            Exit Sub
        End If
        
        Do While Not EOF(iKanalNrFile)
            Line Input #iKanalNrFile, stFilelisteTemp
            'auf Existenz prfen
            If IsFilePath(stFilelisteTemp) Then
                FrmEditor.lstFiles.AddItem stFilelisteTemp
            End If
        Loop
    Close iKanalNrFile
    
    With FrmEditor
        If .lstFiles.ListCount > 0 Then
            'ins Men einfgen
            For i = 0 To .lstFiles.ListCount - 1
                If i = 0 Then
                    .mnuFileName(0).Caption = FileNamekrzen(.lstFiles.List(i))
                Else
                    Load .mnuFileName(i)
                    .mnuFileName(i).Caption = FileNamekrzen(.lstFiles.List(i))
                End If
            Next
        Else
            .mnuFileName(0).Caption = "( Leer )"
        End If
    End With
End If

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Sub DokumenteSchlieen()
On Error GoTo Fehlerbehandlung

Dim Buchstabe As String
'Eingabe\FSO-Drives.frm
Dim fso As New FileSystemObject
Dim dR As Drive
Dim drSpeicherLaufwerk As String

    Screen.MousePointer = vbHourglass
'das aktuelle Verzeichnis wird nun im mdlffentlicheVariablen gespeichert
'fr dr (Laufwerk) sind die ersten 2 Zeichen wichtig und mssen ermittelt werden
Buchstabe = Left(Laufwerk, 2)

'bei nicht betriebsbereitem Laufwerk
On Error Resume Next

For Each dR In fso.Drives
    'Laufwerksbuchstaben einsetzen
    'den Laufwerkstyp ermitteln
    If dR = Buchstabe Then
        Select Case dR.DriveType
            Case Is = CDRom
                drSpeicherLaufwerk = "CD-Rom"
            Case Is = Fixed
                drSpeicherLaufwerk = "Festplatte"
            Case Is = RamDisk
                drSpeicherLaufwerk = "Ram-Disk"
            Case Is = Remote
                drSpeicherLaufwerk = "Netzlaufwerk"
            Case Is = Removable
                drSpeicherLaufwerk = "Wechseldatentrger"
            Case Else
                drSpeicherLaufwerk = "Unbekannt"
        End Select
    'wenn gefunden Schleife verlassen
    Exit For
    End If
Next
Screen.MousePointer = vbDefault

'der Laufwerkstyp ist nun ermittelt
If dR.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Dokumente
'--------------------------------------------------------------------
On Error Resume Next
Fileliste = Laufwerk & "Fileliste.db"

iKanalNrFile = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von lstFile in Fileliste.db
Open Fileliste For Output As iKanalNrFile

    Screen.MousePointer = 13
    
    For FileNr = 0 To FrmEditor.lstFiles.ListCount - 1
         'auf Existenz prfen
         If IsFilePath(FrmEditor.lstFiles.List(FileNr)) Then
             Print #iKanalNrFile, FrmEditor.lstFiles.List(FileNr)
         End If
    Next FileNr
   
   Screen.MousePointer = vbDefault
   
Close iKanalNrFile
End If
    Set fso = Nothing
    Set dR = Nothing

Exit Sub
Fehlerbehandlung:
    Set fso = Nothing
    Set dR = Nothing

Call Fehlermeldung
End Sub

Public Function UmlauteKonvertieren(ByVal sText As String) As String

Dim idummy As Integer
Dim i As Integer
Const sCheck = ""
Const sReplace = "aeoeueAeOeUess"

i = 0
While i < Len(sText)
    i = i + 1
    idummy = InStr(sCheck, Mid$(sText, i, 1))
    If idummy > 0 Then
        sText = Left$(sText, i - 1) + _
        Mid$(sReplace, (idummy - 1) * 2 + 1, 2) + _
        Mid$(sText, i + 1)
        i = i + 1
    End If
Wend
UmlauteKonvertieren = sText
End Function

