Attribute VB_Name = "modcToolTips"
Option Explicit

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wparam As Long, ByVal lparam As Long) As Long
Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Type rect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code As Long
End Type

Private Type NMTTDISPIFNO
    hdr As NMHDR
    lpszText As Long
    szText80(1 To 80) As Byte ' ?? ist das sicher oder besser bytearray?
    hinst As Long
    uFlags As Long
'    lparam As Long
End Type

Private Const TTN_FIRST = -520&

Private Const TTN_GETDISPINFO = (TTN_FIRST - 0)
Private Const TTN_SHOW = (TTN_FIRST - 1)
Private Const TTN_POP = (TTN_FIRST - 2)

Private Const TTN_NEEDTEXT = TTN_GETDISPINFO
Private Const WM_NOTIFY = &H4E&

Public Const PROP = "OLDPROC"
Public Const OBJPROP = "cTTOBJ"

Function ToolTipsCallBackProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wparam As Long, ByVal lparam As Long) As Long
Dim oldFNPtr As Long
Dim nh As NMHDR
Dim tt As cToolTips
Dim lngObj As Long
Dim TTText As NMTTDISPIFNO
Dim Text As String
Dim max As Long

    If msg = WM_NOTIFY Then
        CopyMemory TTText, ByVal lparam, Len(TTText)
        If TTText.hdr.code = TTN_NEEDTEXT Then
            lngObj = GetProp(hwnd, OBJPROP)
            CopyMemory tt, lngObj, 4                ' DANGER!!!
            Text = tt.INTERNALGetTTText(TTText.hdr.idFrom)
            CopyMemory tt, 0&, 4                   ' PUHHHHH !
            max = IIf(Len(Text) > 80, 80, Len(Text)) ' Buffer is max 80 chars!!
            ' 16 = len(NMHDR)+len(long)
            CopyMemory ByVal lparam + 16, ByVal Text, max
            'Exit Function
        End If
    End If
    oldFNPtr = GetProp(hwnd, PROP)
    ToolTipsCallBackProc = CallWindowProc(oldFNPtr, hwnd, msg, wparam, lparam)
End Function


Public Function VB5GetRefCount(ByVal pUnk As IUnknown) As Long
    If pUnk Is Nothing Then Exit Function    ' Get count from magic offset in object
    CopyMemory VB5GetRefCount, ByVal ObjPtr(pUnk) + 4, 4    ' Adjust to account for references to parameter
    VB5GetRefCount = VB5GetRefCount - 3
End Function
