VERSION 5.00
Begin VB.Form FrmBildbetrachter 
   Caption         =   "dein Bildbetrachter"
   ClientHeight    =   4215
   ClientLeft      =   165
   ClientTop       =   765
   ClientWidth     =   5775
   Icon            =   "FrmBildbetrachter.frx":0000
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   4215
   ScaleWidth      =   5775
   StartUpPosition =   3  'Windows-Standard
   Begin RTFEditor.SuperPicCtl SuperPicCtl1 
      Height          =   3255
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3975
      _ExtentX        =   7011
      _ExtentY        =   5741
   End
   Begin VB.Menu mnuBildbetrachter 
      Caption         =   "dein Bildbetrachter"
      Begin VB.Menu mnuBildLaden 
         Caption         =   "ein Bild laden"
      End
      Begin VB.Menu mnuSepLaden 
         Caption         =   "-"
      End
      Begin VB.Menu mnuZoom 
         Caption         =   "den Zoomfaktor ndern"
      End
      Begin VB.Menu mnuSepZoom 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHinweis 
         Caption         =   "Hinweis"
      End
      Begin VB.Menu mnuSepHinweis 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSchlieen 
         Caption         =   "schlieen"
      End
   End
   Begin VB.Menu mnuZoomLevel 
      Caption         =   "Zoom :"
   End
End
Attribute VB_Name = "FrmBildbetrachter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub bmpBildbetrachtereinfgen()
On Error GoTo Fehlerbehandlung

    Dim Menleiste As Long, Men As Long, MenEintrag As Long
    
    Menleiste = GetMenu(Me.hwnd)
    
    'Datei Menicon Hinzufgen
    Men = GetSubMenu(Menleiste, 0)
        MenEintrag = GetMenuItemID(Men, 0)    'laden
        SetMenuItemBitmaps Men, MenEintrag, MF_BITMAP, BitmapsMen(eMenubmps.effnen), 0&
        MenEintrag = GetMenuItemID(Men, 2)    'Zoom
        SetMenuItemBitmaps Men, MenEintrag, MF_BITMAP, BitmapsMen(eMenubmps.eZoom), 0&
        MenEintrag = GetMenuItemID(Men, 4)    'Tip
        SetMenuItemBitmaps Men, MenEintrag, MF_BITMAP, BitmapsMen(eMenubmps.eTip), 0&
        MenEintrag = GetMenuItemID(Men, 6)    'schlieen
        SetMenuItemBitmaps Men, MenEintrag, MF_BITMAP, BitmapsMen(eMenubmps.eFensterschlieen), 0&
        
Exit Sub
Fehlerbehandlung:
End Sub

Private Sub Form_Load()
    Call PlayFensterffnenSound
    '*' By default, use the quickbar.
    '*'
    SuperPicCtl1.UseQuickBar = True
    
    Call bmpBildbetrachtereinfgen
    
    'den ZoomFaktor einstellen
    If m_ZoomFaktor = 0 Then
        m_ZoomFaktor = m_def_ZoomFaktor
    End If

With Me
       'die Mens einfrben
    Set_MenuColor mMenuBarColor, .hwnd, MenuColor, 1
    Set_MenuColor mMenuColor, .hwnd, SubMenuColor, 1
    Set_MenuColor mSysMenuColor, .hwnd, SysMenuColor
End With

    Call MenuSubclassStart(Me.hwnd)
    
End Sub

Private Sub Form_Resize()

On Error Resume Next
With Me
    If .Height <= 5025 Then
        .Height = 5025
    End If
    
    If .Width <= 5895 Then
        .Width = 5895
    End If
End With

    '*' Store the position if the window state is Max'd or Min'd.  Do it before resizing, since a restore will return
    '*' it to this size.
    '*'
    If Me.WindowState = vbMaximized Or Me.WindowState = vbMinimized Then
        SuperPicCtl1.StorePosition
    End If
    
    With Me.SuperPicCtl1
        .Top = 0
        .Left = 0
        .Width = Me.ScaleWidth
        .Height = Me.ScaleHeight
    End With
    
    '*' Recall the position.  Will only work on Restore.
    '*'
    SuperPicCtl1.RecallPosition
        
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call PlayFensterSchlieenSound
    
    Call MenuSubclassEnd(Me.hwnd)
    
End Sub

Private Sub mnuBildLaden_Click()
On Error GoTo Fehlerbehandlung
    Me.SuperPicCtl1.LoadImage
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Private Sub mnuHinweis_Click()
Call PlayHinweisSound
    MsgBox "Dein Bild kann maximal auf das 100 fache vergrert werden !", vbInformation, "dein Bildbetrachter"
Call PlayClickSound
End Sub

Private Sub mnuOptionZoomFaktor_Click()
On Error GoTo Fehlerbehandlung
    FrmZoom.Show vbModal
Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Private Sub mnuSchlieen_Click()
    Unload Me
End Sub

Private Sub mnuZoom_Click()
On Error GoTo Fehlerbehandlung
    FrmZoom.Show vbModal
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Private Sub SuperPicCtl1_ZoomChanged(ByVal ZoomPercent As Long)
Dim xGre As Currency
    '*' Toggle quickbar buttons based upon current percentage.
    '*'
    SuperPicCtl1.AllowZoomIn = (ZoomPercent < m_def_MaxZoom)
    SuperPicCtl1.AllowZoomOut = (ZoomPercent > m_ZoomFaktor)
    xGre = ZoomPercent / 100
If ZoomPercent <> 100 Then
    Me.mnuZoomLevel.Caption = "Zoom : " & ZoomPercent & "% (" & xGre & " fach vergrert)"
Else
    Me.mnuZoomLevel.Caption = "Zoom : " & ZoomPercent & "% ( Originalgre )"
End If
End Sub

Private Sub SuperPicCtl1_ZoomInClick()
    Call PlayClickSound
    '*' Zoom in by an increment of define % if the percentage is less than 10000%
    '*'
    If SuperPicCtl1.Zoom < m_def_MaxZoom Then
        If SuperPicCtl1.Zoom + m_ZoomFaktor > m_def_MaxZoom Then
            Exit Sub
        Else
            SuperPicCtl1.Zoom = SuperPicCtl1.Zoom + m_ZoomFaktor
        End If
    End If
End Sub

Private Sub SuperPicCtl1_ZoomOutClick()
    Call PlayClickSound
    '*' Zoom out by an incrment of define % if the percentage is more than define %
    '*'
    If SuperPicCtl1.Zoom > m_ZoomFaktor Then
        SuperPicCtl1.Zoom = SuperPicCtl1.Zoom - m_ZoomFaktor
    End If
End Sub
