VERSION 5.00
Begin VB.Form FrmEncryptionInPutBox 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Ver- bzw. Entschlsselungs-Code"
   ClientHeight    =   2415
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5670
   Icon            =   "FrmEncryptionInPutBox.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2415
   ScaleWidth      =   5670
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtLenEncryptionKey 
      Alignment       =   2  'Zentriert
      Height          =   285
      Left            =   1440
      TabIndex        =   5
      Top             =   1440
      Width           =   615
   End
   Begin VB.CommandButton cmdKey 
      Caption         =   "#"
      Height          =   375
      Left            =   2160
      TabIndex        =   4
      Top             =   1440
      Width           =   3375
   End
   Begin VB.TextBox txtEingabe 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   120
      PasswordChar    =   "*"
      TabIndex        =   2
      Top             =   1920
      Width           =   5415
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4440
      TabIndex        =   1
      Top             =   240
      Width           =   1095
   End
   Begin VB.CommandButton cmdAbbrechen 
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   4440
      TabIndex        =   0
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Lnge des Cods:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   1440
      Width           =   1200
   End
   Begin VB.Label lblHinweis 
      Alignment       =   2  'Zentriert
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   1  'Fest Einfach
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   1215
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   4215
   End
End
Attribute VB_Name = "FrmEncryptionInPutBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim strEncryption As String
Dim bEncryption As Boolean

Public Property Get strEncryptionKey() As String
    strEncryptionKey = strEncryption
End Property

Public Property Get bolEncryptionKey() As Boolean
    bolEncryptionKey = bEncryption
End Property

Private Sub cmdAbbrechen_Click()
strEncryption = ""
bEncryption = False
    Unload Me
End Sub

Private Sub cmdKey_Click()
With Me
    If .txtLenEncryptionKey.Text <> "" Then
        ' Neuen Key erzeugen
        .txtEingabe.Text = CreateKey(Val(.txtLenEncryptionKey.Text))
        Call PlayClickSound
    Else
        Call PlayHinweisSound
    End If
End With
End Sub

Private Sub cmdOK_Click()
strEncryption = Trim(Me.txtEingabe.Text)
bEncryption = True
    Unload Me
End Sub

Private Sub Form_Activate()
With Me.txtEingabe
    .SelStart = 0
    .SelLength = Len(.Text)
    .SetFocus
End With
End Sub

Private Sub Form_Load()
    strEncryption = ""
End Sub

Private Function CreateKey(ByVal nLen As Integer)
  Dim i As Integer
  Dim nValue As Integer
  Dim sKey As String
  
  For i = 1 To nLen
    Randomize -Timer
    nValue = Int(1000 * Rnd)
    If (nValue Mod 10 = 0) Or (nValue Mod 5 = 0) Or (nValue Mod 3 = 0) Then
      ' Zahl
      Randomize -Timer
      Do
        nValue = Int(8 * Rnd + 1)
      Loop Until nValue >= 1 And nValue <= 9
      sKey = sKey & Chr$(48 + nValue)
    
    Else
      ' Buchstabe
      Randomize -Timer
      Do
        nValue = Int(26 * Rnd)
      Loop Until nValue >= 1 And nValue <= 26 And nValue <> 9 And nValue <> 15
      sKey = sKey & Chr$(64 + nValue)
    End If
  Next i
  
  CreateKey = sKey
End Function

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
With Me.txtEingabe
    If Button = vbLeftButton Then
        'Password verschlsselt anzeigen
        .PasswordChar = "*"
    Else
        'Password unverschlsselt anzeigen
        .PasswordChar = ""
    End If
End With
End Sub

Private Sub txtEingabe_Change()
With Me
    .cmdOK.Enabled = .txtEingabe.Text <> ""
End With
End Sub

Private Sub txtLenEncryptionKey_Change()
With Me
    .cmdKey.Enabled = (IsNumeric(.txtLenEncryptionKey.Text))
End With
End Sub

Private Sub txtLenEncryptionKey_KeyPress(KeyAscii As Integer)
Select Case KeyAscii
    Case 8, 48 To 57
        'nur Zahlen (alles Ok)
    Case Else
        KeyAscii = 0
End Select
End Sub

Private Sub txtLenEncryptionKey_LostFocus()
With Me.txtLenEncryptionKey
    If .Text = "" Then
        Exit Sub
    Else
        If IsNumeric(.Text) Then
            If .Text > Len(FrmEditor.RichTextBox1.Text) Then
                .Text = Len(EncryptionKey)
                Call PlayHinweisSound
                MsgBox "Die Zahl ist zu gro !", vbExclamation, "Ungltig"
                Call PlayClickSound
            End If
        End If
    End If
End With
End Sub
