VERSION 5.00
Begin VB.UserControl Tipps 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   6150
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6810
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   410
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   454
   ToolboxBitmap   =   "Tipps.ctx":0000
   Begin VB.Image Image3 
      Height          =   495
      Left            =   2760
      Top             =   2880
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Image Image2 
      Height          =   480
      Left            =   3960
      Picture         =   "Tipps.ctx":0312
      Top             =   1080
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Label Label2 
      BackStyle       =   0  'Transparent
      Caption         =   "Label2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   720
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   3480
      Picture         =   "Tipps.ctx":0CD4
      Top             =   1080
      Visible         =   0   'False
      Width           =   375
   End
End
Attribute VB_Name = "Tipps"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Dieser Code darf frei verwendet werden, es gibt KEINE Coderechte!
'Fr Verbesserungsvorschlge,... stehe ich gerne zur Verfgung
'Florian Platzer 2003

'http://www.home.pages.at/vbmaster
'vbasic_master@hotmail.com

'23.07.2003

Private Type myTipp
    mBackColor As OLE_COLOR
    mPicture As Picture
    mShowPicture As Boolean
    mTitleText As String
    mTitleFont As Font
    mTitleColor As OLE_COLOR
    mTippText As String
    mTippFont As Font
    mTippColor As OLE_COLOR
    mBorderStyle As cBorderStyle
    mShowTitle As Boolean
    mTitleRect As String
    mTippRect As String
    mPictureRect As String
    mEnabled As Boolean
    mAutoSizeControls As Boolean
    mTippIdx As Long
    mShowTippsNextTime As Integer
End Type

Public Enum cBorderStyle
    [Kein] = 0
    [Fest Einfach] = 1
End Enum

Dim UC As myTipp
Dim h() As String
Dim Tipps() As String
Dim bLoaded As Boolean
Dim sFileName As String
Dim sText As String

Public Event DontShowTipps()
Public Event IndexChanged()
Public Event NoTippsInFile()

Public Property Get BackColor() As OLE_COLOR
BackColor = UC.mBackColor
End Property

Public Property Let BackColor(ByVal vNew As OLE_COLOR)
UC.mBackColor = vNew
PropertyChanged "BackColor"
Call Redraw
End Property

Public Property Get Picture() As Picture
Set Picture = UC.mPicture
End Property

Public Property Set Picture(ByVal vNew As Picture)
Set UC.mPicture = vNew
PropertyChanged "Picture"
Call Redraw
End Property

Public Property Get ShowPicture() As Boolean
ShowPicture = UC.mShowPicture
End Property

Public Property Let ShowPicture(ByVal vNew As Boolean)
UC.mShowPicture = vNew
PropertyChanged "ShowPicture"
Call Redraw
End Property

Public Property Get TitleText() As String
TitleText = UC.mTitleText
End Property

Public Property Let TitleText(ByVal vNew As String)
UC.mTitleText = vNew
PropertyChanged "TitleText"
Call Redraw
End Property

Public Property Get TitleFont() As Font
Set TitleFont = UC.mTitleFont
End Property

Public Property Set TitleFont(ByVal vNew As Font)
Set UC.mTitleFont = vNew
PropertyChanged "TitleFont"
Call Redraw
End Property

Public Property Get TitleColor() As OLE_COLOR
TitleColor = UC.mTitleColor
End Property

Public Property Let TitleColor(ByVal vNew As OLE_COLOR)
UC.mTitleColor = vNew
PropertyChanged "TitleColor"
Call Redraw
End Property

Public Property Get TippText() As String
TippText = UC.mTippText
End Property

Public Property Let TippText(ByVal vNew As String)
UC.mTippText = vNew
PropertyChanged "TippText"
End Property

Public Property Get TippFont() As Font
Set TippFont = UC.mTippFont
End Property

Public Property Set TippFont(ByVal vNew As Font)
Set UC.mTippFont = vNew
PropertyChanged "TippFont"
Call Redraw
End Property

Public Property Get TippColor() As OLE_COLOR
TippColor = UC.mTippColor
End Property

Public Property Let TippColor(ByVal vNew As OLE_COLOR)
UC.mTippColor = vNew
PropertyChanged "TippColor"
Call Redraw
End Property

Public Property Get BorderStyle() As cBorderStyle
BorderStyle = UC.mBorderStyle
End Property

Public Property Let BorderStyle(ByVal vNew As cBorderStyle)
UC.mBorderStyle = vNew
PropertyChanged "BorderStyle"
Call Redraw
End Property

Public Property Get ShowTitle() As Boolean
ShowTitle = UC.mShowTitle
End Property

Public Property Let ShowTitle(ByVal vNew As Boolean)
UC.mShowTitle = vNew
PropertyChanged "ShowTitle"
Call Redraw
End Property

Public Property Get TitleRect() As String
TitleRect = UC.mTitleRect
End Property

Public Property Let TitleRect(ByVal vNew As String)
UC.mTitleRect = vNew
PropertyChanged "TitleRect"
Call Redraw
End Property

Public Property Get TippRect() As String
TippRect = UC.mTippRect
End Property

Public Property Let TippRect(ByVal vNew As String)
UC.mTippRect = vNew
PropertyChanged "TippRect"
Call Redraw
End Property

Public Property Get PictureRect() As String
PictureRect = UC.mPictureRect
End Property

Public Property Let PictureRect(ByVal vNew As String)
UC.mPictureRect = vNew
PropertyChanged "PictureRect"
Call Redraw
End Property

Private Sub Redraw()
On Error Resume Next
'UserControl-Einstellungen vornehmen
UserControl.Enabled = Enabled
UserControl.Cls
UserControl.BackColor = BackColor
UserControl.BorderStyle = BorderStyle

If bLoaded = True Then _
    TippText = Tipps(TippIdx + 1)

Label1.Visible = ShowTitle
'Und Control gestalten
With Label1
Set .Font = TitleFont
.ForeColor = TitleColor
.Caption = TitleText
h = Split(TitleRect, ",")
.Left = CLng(h(0))
.Top = CLng(h(1))
    If AutoSizeControls = False Then
    .AutoSize = False
    .WordWrap = False
    .Width = CLng(h(2))
    .Height = CLng(h(3))
    Else
    .AutoSize = True
    .WordWrap = True
    .Width = UserControl.ScaleWidth - .Left - 10
    'Height wird automatisch eingestellt
    End If
End With

With Label2
Set .Font = TippFont
.ForeColor = TippColor
.Caption = TippText
h = Split(TippRect, ",")
.Left = CLng(h(0))
.Top = CLng(h(1))
    If AutoSizeControls = False Then
    .AutoSize = False
    .WordWrap = False
    .Width = CLng(h(2))
    .Height = CLng(h(3))
    Else
    .AutoSize = True
    .WordWrap = True
    .Width = UserControl.ScaleWidth - .Left - 10
    'Height wird automatisch eingestellt
    End If
End With

If ShowPicture Then
    h = Split(PictureRect, ",")
    If Picture = LoadPicture() Then 'kein Bild manuell ausgewhlt, deshalb Standardbild
    UserControl.PaintPicture Image2.Picture, CLng(h(0)), CLng(h(1)), , , , , , , vbMergePaint
    UserControl.PaintPicture Image1.Picture, CLng(h(0)), CLng(h(1)), , , , , , , vbSrcAnd
    Else
        If AutoSizeControls = False Then
        UserControl.PaintPicture Picture, CLng(h(0)), CLng(h(1)), CLng(h(2)), CLng(h(3))
        Else
        'Image3 ist Dummy fr Bild
        Set Image3.Picture = Picture
        UserControl.PaintPicture Picture, CLng(h(0)), CLng(h(1)), Image3.Width, Image3.Height
        End If
    End If
End If
End Sub

Public Property Get Enabled() As Boolean
Enabled = UC.mEnabled
End Property

Public Property Let Enabled(ByVal vNew As Boolean)
UC.mEnabled = vNew
PropertyChanged "Enabled"
Call Redraw
End Property

Private Sub UserControl_InitProperties()
BackColor = vbWhite
TitleText = "Wussten Sie schon ..."
TippText = "..."
TitleColor = vbBlack
Set TitleFont = UserControl.Font
Set TippFont = UserControl.Font
TippColor = vbBlack
BorderStyle = 1
ShowTitle = True
ShowPicture = True
Enabled = True
Set Picture = Nothing
'Rect: Left, Top, Width (optional), Height (optional)
TitleRect = "50,10,200"
PictureRect = "8,8"
TippRect = "16,56,16"
AutoSizeControls = True
Call Redraw
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
With PropBag
BackColor = .ReadProperty("BackColor", vbWhite)
Set Picture = .ReadProperty("Picture", Nothing)
ShowPicture = .ReadProperty("ShowPicture", True)
TitleText = .ReadProperty("TitleText", "Wussten Sie schon ...")
Set TitleFont = .ReadProperty("TitleFont", UserControl.Font)
TitleColor = .ReadProperty("TitleColor", vbBlack)
TippText = .ReadProperty("TippText", "...")
Set TippFont = .ReadProperty("TippFont", UserControl.Font)
TippColor = .ReadProperty("TippColor", vbBlack)
BorderStyle = .ReadProperty("BorderStyle", 1)
ShowTitle = .ReadProperty("ShowTitle", True)
TitleRect = .ReadProperty("TitleRect", "50,10,200")
TippRect = .ReadProperty("TippRect", "16,56,16")
PictureRect = .ReadProperty("PictureRect", "8,8")
Enabled = .ReadProperty("Enabled", True)
AutoSizeControls = .ReadProperty("AutoSizeControls", True)
End With
End Sub

Private Sub UserControl_Resize()
Call Redraw
End Sub

Private Sub UserControl_Terminate()
On Error Resume Next

If sFileName <> "" Then
Mid(sText, 6, 1) = ShowTippsNextTime
Mid(sText, 17, 1) = TippIdx

Dim number As Long
number = FreeFile

Open sFileName For Output As number
Print #number, sText
Close number

bLoaded = False
End If
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
With PropBag
.WriteProperty "BackColor", BackColor, vbWhite
.WriteProperty "Picture", Picture, Nothing
.WriteProperty "ShowPicture", ShowPicture, True
.WriteProperty "TitleText", TitleText, "Wussten Sie schon ..."
.WriteProperty "TitleFont", TitleFont, UserControl.Font
.WriteProperty "TitleColor", TitleColor, vbBlack
.WriteProperty "TippText", TippText, "..."
.WriteProperty "TippFont", TippFont, UserControl.Font
.WriteProperty "TippColor", TippColor, vbBlack
.WriteProperty "BorderStyle", BorderStyle, 1
.WriteProperty "ShowTitle", ShowTitle, True
.WriteProperty "TitleRect", TitleRect, "50,10,200"
.WriteProperty "TippRect", TippRect, "16,56,16"
.WriteProperty "PictureRect", PictureRect, "8,8"
.WriteProperty "Enabled", Enabled, True
.WriteProperty "AutoSizeControls", AutoSizeControls, True
End With
End Sub

Public Property Get AutoSizeControls() As Boolean
AutoSizeControls = UC.mAutoSizeControls
End Property

Public Property Let AutoSizeControls(ByVal vNew As Boolean)
UC.mAutoSizeControls = vNew
PropertyChanged "AutoSizeControls"
Call Redraw
End Property

Public Sub NextTipp()
If bLoaded = False Then Exit Sub

If TippIdx = TippCount Then
TippIdx = 1
Else
TippIdx = TippIdx + 1
End If

Call Redraw
End Sub

Public Sub PreviousTipp()
If bLoaded = False Then Exit Sub

If TippIdx = 1 Then
TippIdx = TippCount
Else
TippIdx = TippIdx - 1
End If

Call Redraw
End Sub

Public Sub LoadTippData(Filename As String)
On Error GoTo Fehlerbehandlung

bLoaded = False
sFileName = ""
'Die Tipp-Datei muss wie folgt aufgebaut sein:

'show = Wert
'lastIdx = Wert
'Das ist Tipp1
'Das ist Tipp2
'...

'Aufbau:
'show ist der Wert, der angibt, ob die Tipps angezeigt werden sollen oder nicht (zB. bei Programmstart)
'lastIdx ist der  Index des Tipps, der zuletzt angezeigt worden ist

Dim number As Long
Dim size As Long

number = FreeFile

'alles einlesen
Open Filename For Input As number
    size = LOF(number)
    sText = Input(size, number)
Close number

Tipps = Split(sText, vbCrLf) 'so, jetzt haben wir einen Array mit allen Tipps
sFileName = Filename

If UBound(Tipps) = 1 Then 'keine Tipps vorhanden
    RaiseEvent NoTippsInFile
    Exit Sub
End If

If CLng(Replace(Tipps(0), "show=", "")) = 0 Then 'keine Tipps anzeigen
    ShowTippsNextTime = 0
    RaiseEvent DontShowTipps
    Exit Sub
End If

'wenn letzer Eintrag leer, dann raus damit
Do
DoEvents
    If Trim(Tipps(UBound(Tipps)) = "") Or Tipps(UBound(Tipps)) = vbCrLf Then
    ReDim Preserve Tipps(0 To UBound(Tipps) - 1) As String
    sText = Left(sText, InStrRev(sText, vbCrLf))
    End If
Loop Until (Trim(Tipps(UBound(Tipps)) <> "")) And (Tipps(UBound(Tipps)) <> vbCrLf)

ShowTippsNextTime = 1
TippIdx = CLng(Replace(Tipps(1), "lastIdx=", ""))
bLoaded = True
If TippIdx > TippCount Then TippIdx = TippCount

Redraw

Exit Sub
Fehlerbehandlung:
Call Fehlermeldung
End Sub

Public Property Get TippIdx() As Long
Attribute TippIdx.VB_MemberFlags = "400"
TippIdx = UC.mTippIdx
End Property

Public Property Let TippIdx(ByVal vNew As Long)
UC.mTippIdx = vNew
RaiseEvent IndexChanged
End Property

Public Function TippCount() As Long
If bLoaded = False Then
TippCount = -1
Else
TippCount = UBound(Tipps) - 2 + 1 'show und lastIdx gehren weg, aber dann _
                                   noch eins dazu, da Arry mit 0 beginnt
End If
End Function

Public Property Get ShowTippsNextTime() As Integer
Attribute ShowTippsNextTime.VB_MemberFlags = "400"
ShowTippsNextTime = UC.mShowTippsNextTime
End Property

Public Property Let ShowTippsNextTime(ByVal vNew As Integer)
UC.mShowTippsNextTime = vNew
End Property
