VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cToolTips"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Tooltip Stuff und was dazu gehrt
Private Const WM_USER = &H400
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long

Private Type InitCommonControlsEx
    dwSize As Long     '// size of this structure
    dwICC As Long      '// flags indicating which classes to be initialized
End Type

Private Const ICC_LISTVIEW_CLASSES = &H1         '  listview, header
Private Const ICC_TREEVIEW_CLASSES = &H2         '  treeview, tooltips
Private Const ICC_BAR_CLASSES = &H4              '  toolbar, statusbar, trackbar, tooltips
Private Const ICC_TAB_CLASSES = &H8              '  tab, tooltips
Private Const ICC_UPDOWN_CLASS = &H10            '  updown
Private Const ICC_PROGRESS_CLASS = &H20          '  progress
Private Const ICC_HOTKEY_CLASS = &H40            '  hotkey
Private Const ICC_ANIMATE_CLASS = &H80           '  animate
Private Const ICC_WIN95_CLASSES = &HFF
Private Const ICC_DATE_CLASSES = &H100           '  month picker, date picker, time picker, updown
Private Const ICC_USEREX_CLASSES = &H200         '  comboex
Private Const ICC_COOL_CLASSES = &H400           '  rebar (coolbar) control
Private Const ICC_INTERNET_CLASSES = &H800
Private Const ICC_PAGESCROLLER_CLASS = &H1000        '  page scroller
Private Const ICC_NATIVEFNTCTL_CLASS = &H2000        '  native font control

Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (LPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Boolean
Private Declare Function InitCommonControls Lib "comctl32.dll" () As Boolean
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wparam As Long, lparam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_WNDPROC = (-4)
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long

Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WS_EX_TOPMOST = &H8&


Private Const CW_USEDEFAULT = &H80000000

Private Const LPSTR_TEXTCALLBACK = -1&

Private Const TOOLTIPS_CLASS = "tooltips_class32"
Private Const TTS_ALWAYSTIP = &H1
Private Const TTS_NOPREFIX = &H2

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code As Long
End Type

Private Type TOOLINFOCALLBACK
    cbSize As Long
    uFlags As Long
    hwnd As Long
    uId As Long
    RECT As RECT
    hinst As Long
    lpszText As Long 'String
'    lparam As Long
End Type

Private Type TOOLINFOTEXT
    cbSize As Long
    uFlags As Long
    hwnd As Long
    uId As Long
    RECT As RECT
    hinst As Long
    lpszText As String
'    lparam As Long
End Type

Private Const TTF_IDISHWND = &H1

'// Use this to center around trackpoint in trackmode
'// -OR- to center around tool in normal mode.
'// Use TTF_ABSOLUTE to place the tip exactly at the track coords when
'// in tracking mode.  TTF_ABSOLUTE can be used in conjunction with TTF_CENTERTIP
'// to center the tip absolutely about the track point.

Private Const TTF_CENTERTIP = &H2
Private Const TTF_RTLREADING = &H4
Private Const TTF_SUBCLASS = &H10
Private Const TTF_TRACK = &H20
Private Const TTF_ABSOLUTE = &H80
Private Const TTF_TRANSPARENT = &H100
Private Const TTF_DI_SETITEM = &H8000                ' valid only on the TTN_NEEDTEXT callback

Private Const TTDT_AUTOMATIC = 0
Private Const TTDT_RESHOW = 1
Private Const TTDT_AUTOPOP = 2
Private Const TTDT_INITIAL = 3

Private Const TTM_ACTIVATE = (WM_USER + 1)
Private Const TTM_SETDELAYTIME = (WM_USER + 3)
Private Const TTM_ADDTOOL = (WM_USER + 4)
Private Const TTM_DELTOOL = (WM_USER + 5)
Private Const TTM_NEWTOOLRECT = (WM_USER + 6)
Private Const TTM_RELAYEVENT = (WM_USER + 7)

Private Const TTM_GETTOOLINFO = (WM_USER + 8)
Private Const TTM_SETTOOLINFO = (WM_USER + 9)

Private Const TTM_HITTEST = (WM_USER + 10)
Private Const TTM_GETTEXT = (WM_USER + 11)
Private Const TTM_UPDATETIPTEXT = (WM_USER + 12)
Private Const TTM_GETTOOLCOUNT = (WM_USER + 13)
Private Const TTM_ENUMTOOLS = (WM_USER + 14)
Private Const TTM_GETCURRENTTOOL = (WM_USER + 15)
Private Const TTM_WINDOWFROMPOINT = (WM_USER + 16)
Private Const TTM_TRACKACTIVATE = (WM_USER + 17)        '// wParam = TRUE/FALSE start end  lparam = LPTOOLINFO
Private Const TTM_TRACKPOSITION = (WM_USER + 18)        '// lParam = dwPos
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_GETDELAYTIME = (WM_USER + 21)
Private Const TTM_GETTIPBKCOLOR = (WM_USER + 22)
Private Const TTM_GETTIPTEXTCOLOR = (WM_USER + 23)
Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)
Private Const TTM_GETMAXTIPWIDTH = (WM_USER + 25)
Private Const TTM_SETMARGIN = (WM_USER + 26)            '// lParam = lprc
Private Const TTM_GETMARGIN = (WM_USER + 27)            '// lParam = lprc
Private Const TTM_POP = (WM_USER + 28)
Private Const TTM_UPDATE = (WM_USER + 29)

Private Type TT_HITTESTINFO
    hwnd As Long
    pt As POINTAPI
    ti As TOOLINFOTEXT
End Type

Private Const TTN_FIRST = -520&
Private Const TTN_LAST = -549&

Private Const TTN_GETDISPINFO = (TTN_FIRST - 0)
Private Const TTN_SHOW = (TTN_FIRST - 1)
Private Const TTN_POP = (TTN_FIRST - 2)

Private Const TTN_NEEDTEXT = TTN_GETDISPINFO

Private Type NMTTDISPIFNO
    hdr As NMHDR
    lpszText As Long
    szText80 As String * 80 ' ?? ist das sicher oder besser bytearray?
    hinst As Long
    uFlags As Long
    lparam As Long
End Type

Private m_TooltiphWnd  As Long
Private m_SubclassedWnd As Long
Private m_OldWndProcAddr As Long

Event NeedText(ByVal id As Long, ByRef TTText As String)

Private Sub Class_Initialize()
Dim cces As InitCommonControlsEx
    cces.dwSize = Len(cces)
    cces.dwICC = ICC_BAR_CLASSES
    
    InitCommonControlsEx cces
    
    ' tooltip fenster erzeugen
    m_TooltiphWnd = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, ByVal "", TTS_ALWAYSTIP, _
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
          0&, 0&, CLng(App.hInstance), 0&)
    
    m_SubclassedWnd = 0
End Sub

Function INTERNALGetTTText(ByVal id As Long) As String
Dim res As String
    RaiseEvent NeedText(id, res)
    INTERNALGetTTText = res
End Function

Function AddTTRect(hwnd As Long, Left As Long, Top As Long, Right As Long, Bottom As Long, TTText As String, fl As Long, id As Long) As Boolean
Dim ti As TOOLINFOTEXT

    With ti
        .cbSize = Len(ti)
        .hinst = App.hInstance
        .hwnd = hwnd
        .RECT.Left = Left
        .RECT.Top = Top
        .RECT.Right = Right
        .RECT.Bottom = Bottom
        .uFlags = TTF_SUBCLASS Or fl
        .uId = id
        .lpszText = TTText
    End With
    
    AddTTRect = SendMessage(m_TooltiphWnd, TTM_ADDTOOL, 0, ti)
End Function

Function AddTTRectCB(hwnd As Long, Left As Long, Top As Long, Right As Long, Bottom As Long, fl As Long, id As Long) As Boolean
Dim ti As TOOLINFOCALLBACK

    If m_SubclassedWnd = 0 Then
        m_SubclassedWnd = hwnd
        SubclassWindow
    Else
        If hwnd <> m_SubclassedWnd Then
            Err.Raise vbError + 100, "cToolTips", "Class supports only one Subclassed Window"
        End If
    End If
    
    With ti
        .cbSize = Len(ti)
        .hinst = App.hInstance
        .hwnd = hwnd
        .RECT.Left = Left
        .RECT.Top = Top
        .RECT.Right = Right
        .RECT.Bottom = Bottom
        .uFlags = TTF_SUBCLASS Or fl
        .uId = id
        .lpszText = LPSTR_TEXTCALLBACK
    End With
    
    AddTTRectCB = SendMessage(m_TooltiphWnd, TTM_ADDTOOL, 0, ti)
End Function

Property Get Count() As Long
    Count = SendMessage(m_TooltiphWnd, TTM_GETTOOLCOUNT, 0, 0)
End Property

Function DeleteTT(ByVal id As Long) As Boolean
Dim ti As TOOLINFOCALLBACK
    
    With ti
        .cbSize = Len(ti)
        .hinst = App.hInstance
        .hwnd = hwnd
        .uId = id
    End With
    DeleteTT = SendMessage(m_TooltiphWnd, TTM_DELTOOL, 0, ti)
End Function

Function SetNewTTPos(ByVal id As Long, Left As Long, Top As Long, Right As Long, Bottom As Long) As Boolean
Dim ti As TOOLINFOCALLBACK
    
    With ti
        .cbSize = Len(ti)
        .hinst = App.hInstance
        .hwnd = hwnd
        .uId = id
        .RECT.Left = Left
        .RECT.Top = Top
        .RECT.Right = Right
        .RECT.Bottom = Bottom
    End With
    SetNewTTPos = SendMessage(m_TooltiphWnd, TTM_NEWTOOLRECT, 0, ti)
End Function

Property Get BackColor() As Long
    BackColor = SendMessage(m_TooltiphWnd, TTM_GETTIPBKCOLOR, 0&, 0&)
End Property

Property Let BackColor(newval As Long)
    SendMessage m_TooltiphWnd, TTM_SETTIPBKCOLOR, newval, 0&
End Property

Property Get FontColor() As Long
    BackColor = SendMessage(m_TooltiphWnd, TTM_GETTIPTEXTCOLOR, 0&, 0&)
End Property

Property Let FontColor(newval As Long)
    SendMessage m_TooltiphWnd, TTM_SETTIPTEXTCOLOR, newval, 0&
End Property

Property Get MaxTipWidth() As Long
    MaxTipWidth = SendMessage(m_TooltiphWnd, TTM_GETMAXTIPWIDTH, 0&, 0&)
End Property

Property Let MaxTipWidth(newval As Long)
    SendMessage m_TooltiphWnd, TTM_SETMAXTIPWIDTH, newval, ByVal newval
End Property

Property Get hwnd() As Long
    hwnd = m_TooltiphWnd
End Property

Property Let Enabled(newval As Boolean)
    SendMessage m_TooltiphWnd, TTM_ACTIVATE, ByVal newval, ByVal 0&
End Property

Private Sub Class_Terminate()
    DestroyWindow (m_TooltiphWnd)
    If m_SubclassedWnd <> 0 Then UnSubClassWindow
End Sub

Private Sub SubclassWindow()
Dim oldFNPtr As Long
Dim oldcnt As Long

    oldFNPtr = GetWindowLong(m_SubclassedWnd, GWL_WNDPROC)
    SetProp m_SubclassedWnd, PROP, oldFNPtr
    SetProp m_SubclassedWnd, OBJPROP, ObjPtr(Me)
    SetWindowLong m_SubclassedWnd, GWL_WNDPROC, AddressOf ToolTipsCallBackProc
End Sub

Private Sub UnSubClassWindow()
Dim oldFNPtr As Long
    oldFNPtr = GetProp(m_SubclassedWnd, PROP)
    RemoveProp m_SubclassedWnd, PROP
    RemoveProp m_SubclassedWnd, OBJPROP
    SetWindowLong m_SubclassedWnd, GWL_WNDPROC, oldFNPtr
End Sub

